VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "AbstractWebService"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements WebServices.IWebServiceProxi
Implements WebServices.IWebServiceContainer

Private ReflectionType As WebServices.IReflectionType
Private pWebServiceProxiInfo As Variant
Private WSDLReader As New MSSOAPLib30.WSDLReader30
Private WSDLService As MSSOAPLib30.IWSDLService
Private WSDLPort As MSSOAPLib30.IWSDLPort
Private WSDLFileName As String
Private WSMLFileName As String
Private ServiceToFind As String
Private PortToFind As String
Private Initialized As Boolean
Private SoapParser As SoapParser.Adapter
Private Sub Class_Initialize()

Dim customType As Variant

On Error GoTo tractar_error
Set SoapParser = New SoapParser.Adapter
If Not WSDLFileName = "" And Not Initialized Then
        WSDLReader.Load WSDLFileName, WSMLFileName
        If Not WSDLReader Is Nothing Then
            Set WSDLService = SoapParser.GetWSDLService(WSDLReader, ServiceToFind)
            If Not WSDLService Is Nothing Then
                ServiceToFind = WSDLService.Name
                Set WSDLPort = SoapParser.GetWSDLPort(WSDLReader, WSDLService, PortToFind)
                If Not WSDLPort Is Nothing Then PortToFind = WSDLPort.Name
                Set ReflectionType = New AbstractReflectionType
                ReflectionType.Initialize IWebServiceContainer_WebServiceProxi
            End If
            Initialized = True
        End If
    If Not Initialized Then Class_Terminate
End If
Exit Sub

tractar_error:
On Error GoTo 0: SoapParser.ResolverErrorHandler "Initialize", Nothing, Nothing
Class_Terminate

End Sub
Private Sub Class_Terminate()

IWebServiceContainer_Terminate
Initialized = False

End Sub
Private Function IWebServiceContainer_ReflectionType() As WebServices.IReflectionType

If ReflectionType Is Nothing Then Set ReflectionType = New AbstractReflectionType
Set IWebServiceContainer_ReflectionType = ReflectionType

End Function
Private Sub IWebServiceContainer_Terminate()

IWebServiceContainer_WebServiceProxi.Terminate
If Not ReflectionType Is Nothing Then IWebServiceContainer_ReflectionType.Terminate
Set ReflectionType = Nothing

End Sub

Private Function IWebServiceContainer_WebServiceProxi() As WebServices.IWebServiceProxi

Set IWebServiceContainer_WebServiceProxi = Me

End Function
Private Function IWebServiceProxi_AddCustomType(CustomTypeName As String, CustomTypeNamespace As String, CustomTypeProgId As String, CustomTypeIID As String) As Boolean

On Error GoTo t
If Not Initialized Then Class_Initialize
If Initialized Then
    WSDLReader.TypeFactory.AddType Trim(CustomTypeName), Trim(CustomTypeNamespace), Trim(CustomTypeProgId), Trim(CustomTypeIID)
    IWebServiceProxi_AddCustomType = Not WSDLReader.TypeFactory.GetTypeMapperByName(Trim(CustomTypeName), Trim(CustomTypeNamespace)) Is Nothing
End If
t:

End Function
Private Function IWebServiceProxi_ExistType(TypeName As String, TypeNamespace As String) As Boolean

On Error Resume Next
If Initialized Then IWebServiceProxi_ExistType = Not WSDLReader.TypeFactory.GetTypeMapperByName(TypeName, TypeNamespace) Is Nothing

End Function
Private Function IWebServiceProxi_GetSoapInputMessage(OperationName As String, Values As Variant) As String

Dim SoapSerializer As New MSSOAPLib30.SoapSerializer30
Dim dom As MSXML2.IXMLDOMDocument

On Error GoTo t
If Not Initialized Then Class_Initialize
If Initialized Then
    Set dom = New MSXML2.DOMDocument40
    SoapSerializer.Init dom
    SoapParser.GenerateMessageSoapByMemberInfo SoapParser.GetWSDLOperation(WSDLPort, OperationName), WSDLReader.TypeFactory, SoapSerializer, Values
    IWebServiceProxi_GetSoapInputMessage = dom.xml
End If
t:
Set SoapSerializer = Nothing
Set dom = Nothing

End Function
Private Function IWebServiceProxi_GetSoapOutputMessage(OperationName As String, Values As Variant) As String

On Error Resume Next
IWebServiceProxi_GetSoapOutputMessage = SoapParser.ResultOperation(SoapParser.GetWSDLOperation(WSDLPort, OperationName), WSDLPort, WSDLReader.TypeFactory, Values).dom.xml

End Function
Private Function IWebServiceProxi_InvokeArray(MenberName As String, Values() As Variant) As Variant

Dim ret As SoapParser.ReturnValue
Dim myvalues() As Variant

On Error GoTo tractar_error
Class_Initialize
myvalues = Values
Set ret = SoapParser.ExecuteOperation(SoapParser.GetWSDLOperation(WSDLPort, MenberName), WSDLPort, WSDLReader.TypeFactory, myvalues)
If Not HiHaErrorServer(ret) Then
    If Not ret Is Nothing Then
       If Not ret.isObject Then
          IWebServiceProxi_InvokeArray = ret.Value
       Else
          Set IWebServiceProxi_InvokeArray = ret.Value
       End If
    End If
Else
tractar_error:
    If ret Is Nothing Then Set ret = SoapParser.NewReturnValue(Nothing)
    On Error GoTo 0: SoapParser.ResolverErrorHandler MenberName, ret.GetError, Nothing
    Set ret = Nothing
End If

End Function
Private Function IWebServiceProxi_IsAvailable() As Boolean

IWebServiceProxi_IsAvailable = Initialized

End Function
Private Function IWebServiceProxi_PortToName() As String

If Not Initialized Then Class_Initialize
IWebServiceProxi_PortToName = PortToFind

End Function
Private Function IWebServiceProxi_ServiceName() As String

If Not Initialized Then Class_Initialize
IWebServiceProxi_ServiceName = ServiceToFind

End Function
Private Sub IWebServiceProxi_Terminate()

On Error GoTo tractar_error
Set WSDLReader = Nothing
Set WSDLService = Nothing
Set WSDLPort = Nothing
Set SoapParser = Nothing
Exit Sub

tractar_error:
On Error GoTo 0: SoapParser.ResolverErrorHandler "Terminate", Nothing, Nothing

End Sub
Private Function IWebServiceProxi_GetOperationNames() As String()

On Error GoTo tractar_error
Class_Initialize
IWebServiceProxi_GetOperationNames = SoapParser.GetWSDLOperationNames(WSDLPort)
Exit Function

tractar_error:
On Error GoTo 0: SoapParser.ResolverErrorHandler "GetOperationNames", Nothing, Nothing

End Function
Private Function IWebServiceProxi_GetParameterTypeName(OperationName As String, ParameterName As String) As String

On Error GoTo tractar_error
Class_Initialize
IWebServiceProxi_GetParameterTypeName = SoapParser.GetSoapMapperByName(SoapParser.GetWSDLOperation(WSDLPort, OperationName), ParameterName).ElementType

tractar_error:
On Error GoTo 0: SoapParser.ResolverErrorHandler "GetParameterTypeName", Nothing, Nothing

End Function
Private Function IWebServiceProxi_GetParametersNames(OperationName As String) As String()

On Error GoTo tractar_error
Class_Initialize
IWebServiceProxi_GetParametersNames = SoapParser.GetSoapMappersNamesByWSDLOperation(SoapParser.GetWSDLOperation(WSDLPort, OperationName))

tractar_error:
On Error GoTo 0: SoapParser.ResolverErrorHandler "GetParametersNames", Nothing, Nothing

End Function
Private Sub IWebServiceProxi_Initialize(url As String, Optional Service As String = "", Optional Port As String = "", Optional wsmlfile As String = "")

WSDLFileName = url
ServiceToFind = Service
PortToFind = Port
WSMLFileName = wsmlfile
Class_Initialize

End Sub
Private Function IWebServiceProxi_EndInvoke(resultValue As Variant, MemberName As String) As Variant

Dim ret As SoapParser.ReturnValue
On Error GoTo tractar_error
Class_Initialize

Set ret = SoapParser.GetResult(resultValue, SoapParser.GetSoapMapperReturn(SoapParser.GetWSDLOperation(WSDLPort, MemberName)), WSDLReader.TypeFactory)
If Not ret Is Nothing Then
   If Not ret.isObject Then
      IWebServiceProxi_EndInvoke = ret.Value
   Else
      Set IWebServiceProxi_EndInvoke = ret.Value
   End If
End If
If Not HiHaErrorServer(ret) Then Exit Function

tractar_error:
If ret Is Nothing Then Set ret = New SoapParser.ReturnValue
On Error GoTo 0: SoapParser.ResolverErrorHandler MemberName, ret.GetError, Nothing
Set ret = Nothing

End Function
Private Function IWebServiceProxi_Invoke(MenberName As String, ParamArray Values() As Variant) As Variant

Dim ret As SoapParser.ReturnValue
Dim myvalues() As Variant

On Error GoTo tractar_error
Class_Initialize
myvalues = Values
Set ret = SoapParser.ExecuteOperation(SoapParser.GetWSDLOperation(WSDLPort, MenberName), WSDLPort, WSDLReader.TypeFactory, myvalues)
If Not HiHaErrorServer(ret) Then
    If Not ret Is Nothing Then
       If Not ret.isObject Then
          IWebServiceProxi_Invoke = ret.Value
       Else
          Set IWebServiceProxi_Invoke = ret.Value
       End If
    End If
Else
tractar_error:
    If ret Is Nothing Then Set ret = SoapParser.NewReturnValue(Nothing)
    On Error GoTo 0: SoapParser.ResolverErrorHandler MenberName, ret.GetError, Nothing
    Set ret = Nothing
End If

End Function
Private Function IWebServiceProxi_WSDLFileName() As String

If Not Initialized Then Class_Initialize
IWebServiceProxi_WSDLFileName = WSDLFileName

End Function
Private Function IWebServiceProxi_WSMLFileName() As String

If Not Initialized Then Class_Initialize
IWebServiceProxi_WSMLFileName = WSMLFileName

End Function





