VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Adapter"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public Function GetSoapMappersNamesByWSDLOperation(WSDLOperation As MSSOAPLib30.IWSDLOperation) As String()

Dim EnumSoapMappers As MSSOAPLib30.IEnumSoapMappers
Dim SoapMapper As MSSOAPLib30.ISoapMapper
Dim fetched As Long
Dim ret() As String
Dim i As Integer

If WSDLOperation Is Nothing Then Exit Function
WSDLOperation.GetOperationParts EnumSoapMappers
If EnumSoapMappers Is Nothing Then Exit Function
Do
    EnumSoapMappers.Next 1, SoapMapper, fetched
    If fetched = 1 Then
       ReDim ret(i)
       ret(i) = SoapMapper.PartName
       i = i + 1
    End If
Loop While fetched = 1
GetSoapMappersNamesByWSDLOperation = ret

End Function
Public Function GetWSDLOperationNames(WSDLPort As MSSOAPLib30.IWSDLPort) As String()

Dim EnumWSDLOperations As MSSOAPLib30.IEnumWSDLOperations
Dim WSDLOperation As MSSOAPLib30.IWSDLOperation
Dim fetched As Long
Dim ret() As String
Dim i As Integer

If WSDLPort Is Nothing Then Exit Function
WSDLPort.GetSoapOperations EnumWSDLOperations
If EnumWSDLOperations Is Nothing Then Exit Function
Do
    EnumWSDLOperations.Next 1, WSDLOperation, fetched
    If fetched = 1 Then
       ReDim Preserve ret(i)
       ret(i) = Trim(WSDLOperation.Name)
       i = i + 1
    End If
Loop While fetched = 1
GetWSDLOperationNames = ret

End Function
Public Function NewParameterContainer(SoapTypeMapper As MSSOAPLib30.ISoapTypeMapper, Optional Encoding As String = "", Optional flags As Long = 0, Optional EncodingMode As enEncodingStyle = enDocumentLiteral, Optional var As Variant = Nothing) As ParameterContainer

Dim pc As New ParameterContainer

pc.Initialize SoapTypeMapper, Encoding, flags, EncodingMode, isObject(var), var
Set NewParameterContainer = pc

End Function
Public Function GetWSDLService(WSDLReader As MSSOAPLib30.WSDLReader30, ServiceName As String) As MSSOAPLib30.IWSDLService

Dim EnumWSDLService As MSSOAPLib30.IEnumWSDLService
Dim WSDLService As MSSOAPLib30.IWSDLService
Dim fetched As Long

On Error GoTo t
If WSDLReader Is Nothing Then Exit Function
WSDLReader.GetSoapServices EnumWSDLService
If EnumWSDLService Is Nothing Then Exit Function
Do
    EnumWSDLService.Next 1, WSDLService, fetched
    If fetched = 1 Then
        If WSDLService.Name = ServiceName Or ServiceName = "" Then
            Set GetWSDLService = WSDLService
            Exit Function
        End If
    End If
Loop While fetched = 1
t:

End Function
Public Function GetWSDLPort(WSDLReader As MSSOAPLib30.WSDLReader30, WSDLService As MSSOAPLib30.IWSDLService, PortName As String) As MSSOAPLib30.IWSDLPort

Dim EnumWSDLPorts As MSSOAPLib30.IEnumWSDLPorts
Dim WSDLPort As MSSOAPLib30.IWSDLPort
Dim fetched As Long

On Error GoTo t
WSDLService.GetSoapPorts EnumWSDLPorts
If EnumWSDLPorts Is Nothing Then Exit Function
Do
    EnumWSDLPorts.Next 1, WSDLPort, fetched
    If fetched = 1 Then
        If WSDLPort.Name = PortName Or PortName = "" Then
            Set GetWSDLPort = WSDLPort
            Exit Function
        End If
    End If
Loop While fetched = 1
t:

End Function
Public Function GetWSDLOperation(WSDLPort As MSSOAPLib30.IWSDLPort, OperationToFind As String) As MSSOAPLib30.IWSDLOperation

Dim EnumWSDLOperations As MSSOAPLib30.IEnumWSDLOperations
Dim WSDLOperation As MSSOAPLib30.IWSDLOperation

On Error Resume Next
If WSDLPort Is Nothing Then Exit Function
WSDLPort.GetSoapOperations EnumWSDLOperations
If EnumWSDLOperations Is Nothing Then Exit Function
EnumWSDLOperations.Find OperationToFind, WSDLOperation
Set GetWSDLOperation = WSDLOperation

End Function
Public Function GetSoapMapperByName(ByRef WSDLOperation As MSSOAPLib30.IWSDLOperation, Name As String) As MSSOAPLib30.ISoapMapper

End Function
Public Function GetSoapMapperReturn(ByRef WSDLOperation As MSSOAPLib30.IWSDLOperation) As MSSOAPLib30.ISoapMapper

Dim EnumSoapMappers As MSSOAPLib30.IEnumSoapMappers
Dim SoapMapper As MSSOAPLib30.ISoapMapper
Dim fetched As Long

If Not WSDLOperation Is Nothing Then
    WSDLOperation.GetOperationParts EnumSoapMappers
    If Not EnumSoapMappers Is Nothing Then
        Do
            EnumSoapMappers.Next 1, SoapMapper, fetched
            If fetched = 1 Then
                If Not SoapMapper.IsInput Then
                    Set GetSoapMapperReturn = SoapMapper
                    fetched = 0
                End If
            End If
        Loop While fetched = 1
    End If
End If
Set SoapMapper = Nothing
Set EnumSoapMappers = Nothing

End Function
Public Function GetObjectResultBySoapReader(SoapReader As MSSOAPLib30.SoapReader30, SoapTypeMapperFactory As MSSOAPLib30.SoapTypeMapperFactory30, SoapMapper As MSSOAPLib30.ISoapMapper, XMLDOMNode As MSXML2.IXMLDOMNode, OutputSoapTypeMapper As ParameterContainer, ErrorSoapTypeMapper As ParameterContainer) As ReturnValue

Dim i As Integer
Dim mat As Variant
Dim ret As ReturnValue
Dim XMLDOMNodeList As MSXML2.IXMLDOMNodeList

If Not SoapReader Is Nothing Then
    If Not SoapReader.dom.xml = "" Then
        If SoapReader.Fault Is Nothing Then
            If Not OutputSoapTypeMapper Is Nothing Then
                If Not SoapMapper Is Nothing And XMLDOMNode Is Nothing Then Set XMLDOMNode = GetNodeName(SoapReader, SoapReader.dom, "//" & SoapMapper.PartName)
                If Not XMLDOMNode Is Nothing Then
                    If XMLDOMNode.baseName = "Array" And XMLDOMNode.namespaceURI = "http://schemas.xmlsoap.org/soap/encoding/" Then
                       If Not OutputSoapTypeMapper Is Nothing Then
                            Set XMLDOMNodeList = XMLDOMNode.selectNodes("item")
                            mat = OutputSoapTypeMapper.CreateArrayType
                            For i = 0 To XMLDOMNodeList.length
                                ReDim Preserve mat(i)
                                Set ret = GetObjectResultBySoapReader(SoapReader, SoapTypeMapperFactory, SoapMapper, GetNode(SoapReader, XMLDOMNodeList.Item(i)), OutputSoapTypeMapper, ErrorSoapTypeMapper)
                                If ret.isObject Then
                                   Set mat(i) = ret.Value
                                Else
                                   mat(i) = ret.Value
                                End If
                            Next
                       End If
                       Set GetObjectResultBySoapReader = NewReturnValue(mat)
                    Else
                        If Not OutputSoapTypeMapper.SoapTypeMapper Is Nothing Then Set GetObjectResultBySoapReader = NewReturnValue(OutputSoapTypeMapper.SoapTypeMapper.Read(SoapReader, XMLDOMNode, OutputSoapTypeMapper.Encoding, OutputSoapTypeMapper.EncodingMode, OutputSoapTypeMapper.flags))
                    End If
                Else
                    Set GetObjectResultBySoapReader = NewReturnValue(Nothing)
                End If
            Else
                Set GetObjectResultBySoapReader = NewReturnValue(Nothing)
            End If
        Else
            If Not ErrorSoapTypeMapper Is Nothing Then
                If Not ErrorSoapTypeMapper.SoapTypeMapper Is Nothing Then
                    ErrorSoapTypeMapper.SoapTypeMapper.Init SoapTypeMapperFactory, Nothing, Nothing, 0
                    Set GetObjectResultBySoapReader = NewReturnValue(ErrorSoapTypeMapper.SoapTypeMapper.Read(SoapReader, SoapReader.Fault, ErrorSoapTypeMapper.Encoding, ErrorSoapTypeMapper.EncodingMode, ErrorSoapTypeMapper.flags))
                Else
                    Set GetObjectResultBySoapReader = NewReturnValue(SoapReader.Fault)
                End If
            Else
                Set GetObjectResultBySoapReader = NewReturnValue(SoapReader.Fault)
            End If
        End If
    Else
        Set GetObjectResultBySoapReader = NewReturnValue(XMLDOMNode)
    End If
Else
    Set GetObjectResultBySoapReader = NewReturnValue(XMLDOMNode)
End If
Set SoapReader = Nothing
Set XMLDOMNode = Nothing

End Function
Public Sub GenerateMessageSoapByParameterContainer(SoapTypeMapperFactory As MSSOAPLib30.SoapTypeMapperFactory30, ElementType As String, XmlNamespace As String, container As ParameterContainer, SoapSerializer As MSSOAPLib30.SoapSerializer30)

    On Error Resume Next
    If Not container Is Nothing Then
        If Not container.SoapTypeMapper Is Nothing Then
            SoapSerializer.StartElement ElementType, XmlNamespace
            container.SoapTypeMapper.Write SoapSerializer, container.Encoding, container.EncodingMode, container.flags, container.var
            SoapSerializer.EndElement
        End If
    End If

End Sub
Public Sub GenerateMessageSoapByMemberInfo(WSDLOperation As MSSOAPLib30.IWSDLOperation, SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, SoapSerializer As MSSOAPLib30.SoapSerializer30, Values As Variant)

Dim EnumSoapMappers As MSSOAPLib30.IEnumSoapMappers
Dim SoapMapper As MSSOAPLib30.ISoapMapper
Dim fetched As Long

On Error GoTo t
SoapSerializer.StartEnvelope
SoapSerializer.StartBody
SoapSerializer.StartElement WSDLOperation.InputMessage.MessageName, WSDLOperation.InputMessage.MessageNamespace
Set EnumSoapMappers = WSDLOperation.InputMessage.MessageParts

If Not EnumSoapMappers Is Nothing Then
    Do
        EnumSoapMappers.Next 1, SoapMapper, fetched
        If fetched = 1 And Not SoapMapper Is Nothing Then If SoapMapper.IsInput Then GenerateMessageSoapByParameterContainer SoapTypeMapperFactory, IIf(IsSympleType(helper.GetElement(Values, SoapMapper.ParameterOrder)), SoapMapper.ElementName, SoapMapper.ElementType), SoapMapper.XmlNamespace, Me.NewParameterContainer(SoapTypeMapperFactory.GetTypeMapperByName(SoapMapper.ElementType, SoapMapper.XmlNamespace), , , , helper.GetElement(Values, SoapMapper.ParameterOrder)), SoapSerializer
    Loop While fetched = 1
End If

SoapSerializer.EndElement
SoapSerializer.EndBody
SoapSerializer.EndEnvelope

t:
Set SoapMapper = Nothing
Set EnumSoapMappers = Nothing

End Sub

Public Sub GenerateMessageSoap(WSDLReader As MSSOAPLib30.WSDLReader30, WSDLOperation As MSSOAPLib30.IWSDLOperation, parameters As Collection, SoapSerializer As MSSOAPLib30.SoapSerializer30)

Dim EnumSoapMappers As MSSOAPLib30.IEnumSoapMappers
Dim SoapMapper As MSSOAPLib30.ISoapMapper
Dim container As ParameterContainer
Dim fetched As Long
        
On Error GoTo t
SoapSerializer.StartEnvelope
SoapSerializer.StartBody
SoapSerializer.StartElement WSDLOperation.InputMessage.MessageName, WSDLOperation.InputMessage.MessageNamespace
Set EnumSoapMappers = WSDLOperation.InputMessage.MessageParts

Do
    EnumSoapMappers.Next 1, SoapMapper, fetched
    If fetched = 1 And Not SoapMapper Is Nothing Then
        If SoapMapper.IsInput Then
            Set container = parameters(SoapMapper.PartName)
            GenerateMessageSoapByParameterContainer WSDLReader.TypeFactory, SoapMapper.ElementType, SoapMapper.XmlNamespace, container, SoapSerializer
        End If
    End If
Loop While fetched = 1

SoapSerializer.EndElement
SoapSerializer.EndBody
SoapSerializer.EndEnvelope

t:
Set SoapMapper = Nothing
Set EnumSoapMappers = Nothing
Set container = Nothing

End Sub
Public Function ResultOperation(WSDLOperation As MSSOAPLib30.IWSDLOperation, WSDLPort As MSSOAPLib30.IWSDLPort, SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, Values As Variant) As MSSOAPLib30.SoapReader30

Dim SoapConnectorFactory As New MSSOAPLib30.SoapConnectorFactory30
Dim SoapSerializer As MSSOAPLib30.SoapSerializer30
Dim SoapConnector As MSSOAPLib30.ISoapConnector
Dim SoapReader As MSSOAPLib30.SoapReader30

On Error GoTo t
If Not WSDLOperation Is Nothing And Not WSDLPort Is Nothing And Not SoapTypeMapperFactory Is Nothing Then
    Set SoapSerializer = New SoapSerializer30
    Set SoapConnector = SoapConnectorFactory.CreatePortConnector(WSDLPort)
    SoapConnector.ConnectWSDL WSDLPort
    SoapConnector.BeginMessageWSDL WSDLOperation
    SoapSerializer.Init SoapConnector.InputStream
    GenerateMessageSoapByMemberInfo WSDLOperation, SoapTypeMapperFactory, SoapSerializer, Values
    SoapConnector.EndMessage
    Set SoapReader = New MSSOAPLib30.SoapReader30
    SoapReader.Load SoapConnector.OutputStream
    Set ResultOperation = SoapReader
End If
t:

Set SoapSerializer = Nothing
Set SoapConnector = Nothing

End Function
Public Function ExecuteOperation(WSDLOperation As MSSOAPLib30.IWSDLOperation, WSDLPort As MSSOAPLib30.IWSDLPort, SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, Values As Variant) As ReturnValue

Dim SoapMapper As MSSOAPLib30.ISoapMapper

Set SoapMapper = GetSoapMapperReturn(WSDLOperation)
If Not SoapMapper Is Nothing Then
    Set ExecuteOperation = GetObjectResultBySoapReader(Me.ResultOperation(WSDLOperation, WSDLPort, SoapTypeMapperFactory, Values), SoapTypeMapperFactory, SoapMapper, Nothing, NewParameterContainer(SoapTypeMapperFactory.GetTypeMapperByName(SoapMapper.ElementType, SoapMapper.XmlNamespace)), NewParameterContainer(GetTypeMapper(SoapTypeMapperFactory, "SoapError", Nothing)))
Else
   Set ExecuteOperation = NewReturnValue(Null)
End If
Set SoapMapper = Nothing

End Function
Public Function GetTypeMapper(pSoapTypeMapperFactory As MSSOAPLib30.SoapTypeMapperFactory30, TypeName As String, par_SchemaNode As IXMLDOMNode) As MSSOAPLib30.ISoapTypeMapper

Set GetTypeMapper = helper.GetTypeMapper(pSoapTypeMapperFactory, TypeName, par_SchemaNode)

End Function
Public Function NewReturnValue(Value As Variant) As ReturnValue

Dim ret As New ReturnValue

On Error Resume Next
ret.isObject = isObject(Value)
If ret.isObject Then
    Set ret.Value = Nothing
    Set ret.Value = Value
Else
    ret.Value = Value
End If
Set NewReturnValue = ret

End Function
Public Function GetNodeSchema(ByVal Factory As MSSOAPLib30.ISoapTypeMapperFactory, XMLDOMNode As MSXML2.IXMLDOMNode) As MSXML2.IXMLDOMNode

Dim dom As MSXML2.IXMLDOMDocument

On Error Resume Next
If Not Factory Is Nothing Then
    Select Case XMLDOMNode.baseName
           Case "element"
                If Not XMLDOMNode.Attributes.getNamedItem("type").nodeValue Like "xsd:*" Then Set GetNodeSchema = Factory.GetDefinitionsNode(Split(XMLDOMNode.Attributes.getNamedItem("type").nodeValue, ":")(1), XMLDOMNode.ownerDocument.selectSingleNode("//namespace::" & Split(XMLDOMNode.Attributes.getNamedItem("type").nodeValue, ":")(0)).nodeValue, False)
                If XMLDOMNode.Attributes.getNamedItem("type").nodeValue Like "xsd:*" Then
                   Set dom = New MSXML2.DOMDocument40
                   dom.LoadXml "<enXSD" & Split(XMLDOMNode.Attributes.getNamedItem("type").nodeValue, ":")(1) & "/>"
                   Set GetNodeSchema = dom.childNodes(0)
                   Set dom = Nothing
                End If
    End Select
End If

End Function
Public Function GetNodeTypeSchema(XMLDOMNode As MSXML2.IXMLDOMNode, Name As String) As MSXML2.IXMLDOMNode

If Not XMLDOMNode Is Nothing Then Set GetNodeTypeSchema = XMLDOMNode.selectSingleNode(".//*[@name='" & Name & "']")

End Function

Public Function GetNodeNameSchema(ByVal Factory As MSSOAPLib30.ISoapTypeMapperFactory, XMLDOMNode As MSXML2.IXMLDOMNode, Name As String) As MSXML2.IXMLDOMNode

If Not XMLDOMNode Is Nothing Then Set GetNodeNameSchema = GetNodeSchema(Factory, GetNodeTypeSchema(XMLDOMNode, Name))

End Function

Public Function GetNode(ByVal SoapReader As MSSOAPLib30.ISoapReader, XMLDOMNode As MSXML2.IXMLDOMNode) As MSXML2.IXMLDOMNode

Set GetNode = helper.GetNode(SoapReader, XMLDOMNode)

End Function
Public Function GetNodeName(ByVal SoapReader As MSSOAPLib30.ISoapReader, XMLDOMNode As MSXML2.IXMLDOMNode, Name As String) As MSXML2.IXMLDOMNode

Set GetNodeName = helper.GetNodeName(SoapReader, XMLDOMNode, Name)

End Function
Public Function GetResult(selection As Variant, SoapMapper As MSSOAPLib30.ISoapMapper, SoapTypeMapperFactory As ISoapTypeMapperFactory) As SoapParser.ReturnValue

Dim SoapReader As New MSSOAPLib30.SoapReader30
Dim XMLDOMSelection As MSXML2.IXMLDOMSelection
Dim SoapTypeMapper As ISoapTypeMapper
Dim ret As SoapParser.ReturnValue
Dim mat As Variant
Dim i As Integer

If TypeName(selection) = "IXMLDOMSelection" Then
    Set XMLDOMSelection = selection
    SoapReader.Load XMLDOMSelection.context.ownerDocument
    Set GetResult = GetObjectResultBySoapReader(SoapReader, SoapTypeMapperFactory, SoapMapper, XMLDOMSelection.context, NewParameterContainer(SoapTypeMapperFactory.GetTypeMapperByName(SoapMapper.ElementType, SoapMapper.XmlNamespace)), NewParameterContainer(GetTypeMapper(SoapTypeMapperFactory, "SoapError", Nothing)))
ElseIf IsArray(selection) And TeElements(selection) Then
    mat = CreateArrayType(UCase(TypeName(SoapMapper.ComValue)) = "OBJECT()")
    Set SoapTypeMapper = GetSoapTypeMapper(SoapTypeMapperFactory, SoapMapper.SchemaNode, TypeName(SoapMapper.ComValue) Like "*()")
    ReDim mat(LBound(selection) To UBound(selection))
    For i = LBound(selection) To UBound(selection)
        Set XMLDOMSelection = selection(i)
        SoapReader.Load XMLDOMSelection.context.ownerDocument
        If TypeName(selection(i)) = "IXMLDOMSelection" Then
            Set ret = GetObjectResultBySoapReader(SoapReader, SoapTypeMapperFactory, SoapMapper, XMLDOMSelection.context, NewParameterContainer(SoapTypeMapper), NewParameterContainer(GetTypeMapper(SoapTypeMapperFactory, "SoapError", Nothing)))
        Else
            Set ret = NewReturnValue(selection(i))
        End If
        If ret.isObject Then
           Set mat(i) = ret.Value
        Else
           mat(i) = ret.Value
        End If
    Next
    Set GetResult = NewReturnValue(mat)
Else
    Set GetResult = NewReturnValue(selection)
End If
Set XMLDOMSelection = Nothing
Set SoapTypeMapper = Nothing
Set SoapReader = Nothing
Set ret = Nothing

End Function
Public Sub ResolverErrorHandler(str_Function As String, WebServiceError As SoapParser.SoapError, SoapClient As MSSOAPLib30.SoapClient30)

helper.ResolverErrorHandler str_Function, WebServiceError, SoapClient

End Sub
Public Function HiHaErrorServer(ret As SoapParser.ReturnValue) As Boolean

HiHaErrorServer = helper.HiHaErrorServer(ret)

End Function
Public Function GetSoapTypeMapper(SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, XMLDOMNode As MSXML2.IXMLDOMNode, Optional GetTypeItemArray As Boolean = False) As ISoapTypeMapper

Dim Value As Integer

If Not XMLDOMNode Is Nothing Then
    If Not GetTypeItemArray Then
        If XMLDOMNode.namespaceURI = "" Then
            If XMLDOMNode.parentNode Is XMLDOMNode.ownerDocument Then
                Value = helper.GetEnumValue(tli.TLIApplication.InterfaceInfoFromObject(SoapTypeMapperFactory).Parent, "enXSDType", XMLDOMNode.baseName, -1)
            Else
                Value = helper.GetEnumValue(tli.TLIApplication.InterfaceInfoFromObject(SoapTypeMapperFactory).Parent, "enXSDType", Me.GetNodeNameSchema(SoapTypeMapperFactory, SoapTypeMapperFactory.GetDefinitionsNode(XMLDOMNode.parentNode.baseName, XMLDOMNode.parentNode.namespaceURI, False), XMLDOMNode.baseName).baseName, -1)
            End If
            Set GetSoapTypeMapper = SoapTypeMapperFactory.GetMapper(Value, Nothing)
        ElseIf XMLDOMNode.namespaceURI = "http://www.w3.org/2001/XMLSchema" Then
            Set GetSoapTypeMapper = SoapTypeMapperFactory.GetTypeMapper(XMLDOMNode)
        Else
            Set GetSoapTypeMapper = SoapTypeMapperFactory.GetTypeMapperByName(XMLDOMNode.baseName, XMLDOMNode.namespaceURI)
        End If
    Else
       If Not XMLDOMNode.parentNode Is Nothing Then Set GetSoapTypeMapper = GetSoapTypeMapper(SoapTypeMapperFactory, Me.GetNodeNameSchema(SoapTypeMapperFactory, XMLDOMNode.parentNode.parentNode, (Split(Split(GetAttribute(XMLDOMNode.selectSingleNode(".//*[@ref='soapenc:arrayType']"), "wsdl:arrayType") & ":", ":")(1) & "[", "[")(0))))
    End If
End If

End Function
Function GetIsObject(SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, XMLDOMNode As MSXML2.IXMLDOMNode) As Boolean

GetIsObject = XMLDOMNode.namespaceURI = ""

End Function
Function GetElement(SoapTypeMapperFactory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_soapreader As MSSOAPLib30.ISoapReader, ByVal par_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long) As SoapParser.ReturnValue

Dim SoapTypeMapper As ISoapTypeMapper
Dim ret As ReturnValue
    
    Set SoapTypeMapper = GetSoapTypeMapper(SoapTypeMapperFactory, par_Node)
    If Not SoapTypeMapper Is Nothing Then
        Set ret = Me.NewReturnValue(SoapTypeMapper.Read(par_soapreader, par_Node, par_encoding, par_encodingMode, par_flags))
        If ret.IsEmpty Then ret.InitilaizeEmptyValue Me.GetIsObject(SoapTypeMapperFactory, par_Node)
    Else
        Set ret = Me.NewReturnValue(Nothing)
    End If
    Set GetElement = ret
    
End Function
Public Function SoapTypeMapperRead(m_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_soapreader As MSSOAPLib30.ISoapReader, ByVal par_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long) As Collection

Dim llista As New Collection
Dim XMLDOMNode As MSXML2.IXMLDOMNode

On Error Resume Next
If Not par_soapreader Is Nothing And Not par_Node Is Nothing Then
    For Each XMLDOMNode In par_Node.selectNodes("./*")
        llista.Add Me.GetElement(m_Factory, par_soapreader, SoapParser.GetNode(par_soapreader, XMLDOMNode), par_encoding, par_encodingMode, par_flags), UCase(XMLDOMNode.baseName)
    Next
End If
Set SoapTypeMapperRead = llista

End Function
Public Sub SoapTypeMapperWriteObject(obj As Variant, m_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_ISoapSerializer As MSSOAPLib30.ISoapSerializer, ByVal schema_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long)

Dim i As Integer
Dim node As MSXML2.IXMLDOMNode
Dim Interface As tli.InterfaceInfo
Dim ElementType As String, XmlNamespace As String

Set Interface = tli.TLIApplication.InterfaceInfoFromObject(obj)
If Not Interface Is Nothing And Not obj Is Nothing Then
    For i = 1 To Interface.Members.Count
       If Interface.Members(i).InvokeKind = INVOKE_PROPERTYGET Then
          Me.SoapTypeMapperWriteObjectMember m_Factory, par_ISoapSerializer, schema_Node, par_encoding, par_encodingMode, par_flags, Interface.Members(i).Name, CallByName(obj, Interface.Members(i).Name, INVOKE_PROPERTYGET)
          'Set node = Me.GetNodeTypeSchema(schema_Node, Interface.Members(i).Name)
          'If Not node Is Nothing Then
          '   ElementType = Split(GetAttribute(node, "type") & ":", ":")(1)
          '   XmlNamespace = GetNameSpace(node.ownerDocument, Split(GetAttribute(node, "type") & ":", ":")(0))
          '   Set node = Me.GetNodeSchema(m_Factory, node)
          '   If Not node Is Nothing Then
          '      If UCase(XmlNamespace) = UCase("http://www.w3.org/2001/XMLSchema") Then
          '          Me.GenerateMessageSoapByParameterContainer m_Factory, Interface.Members(i).Name, XmlNamespace, Me.NewParameterContainer(GetSoapTypeMapper(m_Factory, node), par_encoding, par_encodingMode, par_flags, CallByName(obj, Interface.Members(i).Name, INVOKE_PROPERTYGET)), par_ISoapSerializer
          '      Else
          '          Me.GenerateMessageSoapByParameterContainer m_Factory, ElementType, XmlNamespace, Me.NewParameterContainer(GetSoapTypeMapper(m_Factory, node), par_encoding, par_encodingMode, par_flags, CallByName(obj, Interface.Members(i).Name, INVOKE_PROPERTYGET)), par_ISoapSerializer
          '      End If
          '   End If
          'End If
       End If
    Next
End If

End Sub
Public Function SoapTypeMapperWriteObjectMember(m_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_ISoapSerializer As MSSOAPLib30.ISoapSerializer, ByVal schema_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long, Name As String, Value As Variant)

Dim node As MSXML2.IXMLDOMNode
Dim ElementType As String, XmlNamespace As String
    
    Set node = Me.GetNodeTypeSchema(schema_Node, Name)
    If Not node Is Nothing Then
       ElementType = Split(GetAttribute(node, "type") & ":", ":")(1)
       XmlNamespace = GetNameSpace(node.ownerDocument, Split(GetAttribute(node, "type") & ":", ":")(0))
       Set node = Me.GetNodeSchema(m_Factory, node)
       If Not node Is Nothing Then
          'If UCase(XmlNamespace) = UCase("http://www.w3.org/2001/XMLSchema") Then
          If helper.IsSympleType(Value) Then
              Me.GenerateMessageSoapByParameterContainer m_Factory, Name, XmlNamespace, Me.NewParameterContainer(GetSoapTypeMapper(m_Factory, node), par_encoding, par_encodingMode, par_flags, Value), par_ISoapSerializer
          Else
              Me.GenerateMessageSoapByParameterContainer m_Factory, ElementType, XmlNamespace, Me.NewParameterContainer(GetSoapTypeMapper(m_Factory, node), par_encoding, par_encodingMode, par_flags, Value), par_ISoapSerializer
          End If
       End If
    End If

End Function
Public Function SoapTypeMapperReadObject(objName As String, m_Factory As MSSOAPLib30.ISoapTypeMapperFactory, ByVal par_soapreader As MSSOAPLib30.ISoapReader, ByVal par_Node As MSXML2.IXMLDOMNode, ByVal par_encoding As String, ByVal par_encodingMode As MSSOAPLib30.enEncodingStyle, ByVal par_flags As Long) As Variant

Dim i As Integer
Dim obj As Variant
Dim Interface As tli.InterfaceInfo
Dim llista As Collection

On Error Resume Next
Set obj = CreateObject(objName)
If Not obj Is Nothing Then
    Set Interface = tli.TLIApplication.InterfaceInfoFromObject(obj)
    Set llista = Me.SoapTypeMapperRead(m_Factory, par_soapreader, par_Node, par_encoding, par_encodingMode, par_flags)
    If Not Interface Is Nothing And Not llista Is Nothing And Not obj Is Nothing Then
        For i = 1 To Interface.Members.Count
           If Interface.Members(i).InvokeKind = INVOKE_PROPERTYPUT Or Interface.Members(i).InvokeKind = INVOKE_PROPERTYPUTREF Then CallByName obj, Interface.Members(i).Name, Interface.Members(i).InvokeKind, GetValue(llista, UCase(Interface.Members(i).Name))
        Next
    End If
End If
Set SoapTypeMapperReadObject = obj

End Function

