VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoapTypeMapperFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Implements SoapParser.ISoapTypeMapperFactory
Private pSoapTypeMapperFactory As MSSOAPLib30.SoapTypeMapperFactory30

Private Function ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo(VarType As VarTypeInfo) As String

Dim name As String

If Not VarType.TypeInfo Is Nothing Then
    name = VarType.TypeInfo.name
    If name Like "_*" Then name = Mid(name, 2)
Else

End If
ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo = name

End Function

Private Function ISoapTypeMapperFactory_GetTypeFactory() As MSSOAPLib30.ISoapTypeMapperFactory

Set ISoapTypeMapperFactory_GetTypeFactory = pSoapTypeMapperFactory

End Function
Private Function ISoapTypeMapperFactory_GetTypeMapper(TypeName As String, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

On Error GoTo t
Select Case TypeName
       Case "SoapError"
            If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeMapper = New SoapParser.SoapErrorTypeMapper
       Case Else
            If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(GetEnumValue(tli.TLIApplication.InterfaceInfoFromObject(pSoapTypeMapperFactory).Parent, "enXSDType", TypeName, enXSDUndefined), par_SchemaNode)
End Select

Exit Function

Select Case TypeName
       Case "enXSDarray"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDarray, par_SchemaNode)
       Case "enXSDbase64binary", "base64"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDbase64binary, par_SchemaNode)
       Case "enXSDboolean", "Boolean"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDboolean, par_SchemaNode)
       Case "enXSDbyte", "Byte"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDbyte, par_SchemaNode)
       Case "enXSDcentury"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDcentury, par_SchemaNode)
       Case "enXSDdate", "Date"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDdate, par_SchemaNode)
       Case "enXSDdecimal"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDdecimal, par_SchemaNode)
       Case "enXSDDouble", "Double"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDDouble, par_SchemaNode)
       Case "enXSDduration"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDduration, par_SchemaNode)
       Case "enXSDentities"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDentities, par_SchemaNode)
       Case "enXSDentity"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDentity, par_SchemaNode)
       Case "enXSDfloat"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDfloat, par_SchemaNode)
       Case "enXSDgDay"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDgDay, par_SchemaNode)
       Case "enXSDgMonth"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDgMonth, par_SchemaNode)
       Case "enXSDgMonthDay"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDgMonthDay, par_SchemaNode)
       Case "enXSDgYear"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDgYear, par_SchemaNode)
       Case "enXSDid"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDid, par_SchemaNode)
       Case "enXSDidRef"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDidRef, par_SchemaNode)
       Case "enXSDidRefs"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDidRefs, par_SchemaNode)
       Case "enXSDint"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDint, par_SchemaNode)
       Case "enXSDinteger", "Integer"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDinteger, par_SchemaNode)
       Case "enXSDlanguage"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDlanguage, par_SchemaNode)
       Case "enXSDlong", "Long"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDlong, par_SchemaNode)
       Case "enXSDname"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDname, par_SchemaNode)
       Case "enXSDncname"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDncname, par_SchemaNode)
       Case "enXSDnegativeInteger"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnegativeInteger, par_SchemaNode)
       Case "enXSDnmtoken"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnmtoken, par_SchemaNode)
       Case "enXSDnmtokens"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnmtokens, par_SchemaNode)
       Case "enXSDnonNegativeInteger"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnonNegativeInteger, par_SchemaNode)
       Case "enXSDnonpositiveInteger"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnonpositiveInteger, par_SchemaNode)
       Case "enXSDnormalizedString"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnormalizedString, par_SchemaNode)
       Case "enXSDnotation"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDnotation, par_SchemaNode)
       Case "enXSDpositiveInteger"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDpositiveInteger, par_SchemaNode)
       Case "enXSDQName"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDQName, par_SchemaNode)
       Case "enXSDrecurringDuration"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDrecurringDuration, par_SchemaNode)
       Case "enXSDshort"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDshort, par_SchemaNode)
       Case "enXSDstring", "String"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDstring, par_SchemaNode)
       Case "enXSDtime"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDtime, par_SchemaNode)
       Case "enXSDtimeInstant"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDtimeInstant, par_SchemaNode)
       Case "enXSDtimePeriod"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDtimePeriod, par_SchemaNode)
       Case "enXSDtoken"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDtoken, par_SchemaNode)
       Case "enXSDunsignedByte"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDunsignedByte, par_SchemaNode)
       Case "enXSDunsignedInt"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDunsignedInt, par_SchemaNode)
       Case "enXSDunsignedLong"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDunsignedLong, par_SchemaNode)
       Case "enXSDunsignedShort"
            Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetMapper(enXSDunsignedShort, par_SchemaNode)
       Case "SoapError"
            If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeMapper = New SoapParser.SoapErrorTypeMapper
    End Select
t:

End Function

Private Function ISoapTypeMapperFactory_GetTypeMapperByTypeInfo(VarType As VarTypeInfo, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

Set ISoapTypeMapperFactory_GetTypeMapperByTypeInfo = ISoapTypeMapperFactory_GetTypeMapper(ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo(VarType), par_SchemaNode)

End Function

Private Function ISoapTypeMapperFactory_GetTypeMapperBySoapMapper(SoapMapper As MSSOAPLib30.ISoapMapper, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

End Function

Private Sub ISoapTypeMapperFactory_Initialize(SoapTypeMapperFactory As Object)

If TypeOf SoapTypeMapperFactory Is MSSOAPLib30.SoapTypeMapperFactory30 Then Set pSoapTypeMapperFactory = SoapTypeMapperFactory

End Sub

