VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "SoapTypeMapperFactory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Implements soapparser.ISoapTypeMapperFactory

Private pSoapTypeMapperFactory As soapparser.ISoapTypeMapperFactory

Private Sub Class_Initialize()

Set pSoapTypeMapperFactory = Nothing

End Sub

Private Sub Class_Terminate()

Set pSoapTypeMapperFactory = Nothing

End Sub

Private Function ISoapTypeMapperFactory_GetTypeFactory() As MSSOAPLib30.ISoapTypeMapperFactory

If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeFactory = pSoapTypeMapperFactory.GetTypeFactory

End Function

Private Function ISoapTypeMapperFactory_GetTypeMapper(TypeName As String, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

Select Case TypeName
       Case "Area"
            Set ISoapTypeMapperFactory_GetTypeMapper = New AreaTypeMapper
       Case "DocumentInfo"
            Set ISoapTypeMapperFactory_GetTypeMapper = New DocumentInfoTypeMapper
       Case "ParsingOcrResult"
            Set ISoapTypeMapperFactory_GetTypeMapper = New ParsingOcrResultTypeMapper
       Case "TemplateInfo"
            Set ISoapTypeMapperFactory_GetTypeMapper = New TemplateInfoTypeMapper
       Case "Uri"
            Set ISoapTypeMapperFactory_GetTypeMapper = New DownloadFileTypeMapper
       Case "DownloadFile"
            Set ISoapTypeMapperFactory_GetTypeMapper = New DownloadFileTypeMapper
       Case Else
            If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeMapper = pSoapTypeMapperFactory.GetTypeMapper(TypeName, par_SchemaNode)
End Select

End Function
Private Function ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo(VarType As VarTypeInfo) As String

Dim name As String

If Not VarType.TypeInfo Is Nothing Then
    name = VarType.TypeInfo.name
    If name Like "_*" Then name = Mid(name, 2)
Else
    If Not pSoapTypeMapperFactory Is Nothing Then name = pSoapTypeMapperFactory.GetNameTypeMapperByTypeInfo(VarType)
End If
ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo = name

End Function
Private Function ISoapTypeMapperFactory_GetTypeMapperByTypeInfo(VarType As VarTypeInfo, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

Set ISoapTypeMapperFactory_GetTypeMapperByTypeInfo = ISoapTypeMapperFactory_GetTypeMapper(ISoapTypeMapperFactory_GetNameTypeMapperByTypeInfo(VarType), par_SchemaNode)

End Function
Private Function ISoapTypeMapperFactory_GetTypeMapperBySoapMapper(SoapMapper As MSSOAPLib30.ISoapMapper, Optional par_SchemaNode As MSXML2.IXMLDOMNode = Nothing) As MSSOAPLib30.ISoapTypeMapper

If Not pSoapTypeMapperFactory Is Nothing Then Set ISoapTypeMapperFactory_GetTypeMapperBySoapMapper = pSoapTypeMapperFactory.GetTypeFactory

End Function
Private Sub ISoapTypeMapperFactory_Initialize(SoapTypeMapperFactory As Object)

If TypeOf SoapTypeMapperFactory Is soapparser.ISoapTypeMapperFactory Then Set pSoapTypeMapperFactory = SoapTypeMapperFactory

End Sub


