VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "WSFactoryInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private current As IWSBaseInfo
Friend Property Get base() As IWSBaseInfo

Set base = current

End Property
Friend Sub LoadXml(xml As String)

Dim DOM As MSXML2.IXMLDOMDocument

Set DOM = New MSXML2.DOMDocument40
Set current = Nothing
If DOM.LoadXml(xml) Then Me.Load DOM
Set DOM = Nothing

End Sub
Friend Sub Load(DOM As MSXML2.IXMLDOMDocument)

Dim base As New WSBaseInfoXml

Set current = base.CreateBase(DOM.selectSingleNode("/WebServices"))
Set base = Nothing

End Sub
Public Property Get ContainerInfo(WebService As Variant) As WSContainerInfo

If current Is Nothing Then Exit Property
Dim wContainerInfo As New WSContainerInfo

If TypeName(WebService) = "Integer" Then Set wContainerInfo.base = QueryItem(current).Item("/WebServices/WebService[" & WebService + 1 & "]")
If TypeName(WebService) = "String" Then Set wContainerInfo.base = QueryItem(current).Item("/WebServices/WebService[@id='" & WebService & "']")
If Not wContainerInfo.base Is Nothing Then Set ContainerInfo = wContainerInfo
Set wContainerInfo = Nothing

End Property
Public Property Get Count() As Integer

If current Is Nothing Then Exit Property
Count = current.Count("/WebServices/WebService")

End Property
Public Function Add(Container As WSContainerInfo) As Boolean

If current Is Nothing Or Container Is Nothing Then Exit Function
If Me.ExistContainerInfo(Container.Id) Then Exit Function
If Container.WSReferenciableInfo.isReference Then If Not Me.ExistContainerInfo(Container.WSReferenciableInfo.KeyReferenceName) Then Exit Function
Add = Container.base.Append(QueryItem(current).Item("/WebServices"))

End Function
Public Function Delete(Container As WSContainerInfo) As Boolean

If current Is Nothing Or Container Is Nothing Then Exit Function
If Container.WSReferenciableInfo.ReferencesCount = 0 And Not Container.WSReferenciableInfo.isReference Then Delete = Container.base.UnAppend(Me.base)
 
End Function
Public Property Get GlobalTypes() As WSTypesInfo

If current Is Nothing Then Exit Property
Dim TypesInfo As New WSTypesInfo
Set TypesInfo.base = QueryItem(current).Item("/WebServices/WebServiceGlobalTypes")
Set GlobalTypes = TypesInfo
Set TypesInfo = Nothing

End Property
Public Sub ResetFactoryInfo()

Dim cadena As String

cadena = cadena & "<?xml version='1.0'?>" & Chr(13)
cadena = cadena & "<!DOCTYPE WebServices [" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServices (WebService*,WebServiceGlobalTypes)>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebService (WebServiceConnection,WebServiceContainer,WebServiceTypes)>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServiceGlobalTypes (WebServiceType*)>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServiceTypes (WebServiceType*)>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServiceConnection EMPTY>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServiceContainer EMPTY>" & Chr(13)
cadena = cadena & "  <!ELEMENT WebServiceType EMPTY>" & Chr(13)
cadena = cadena & "  <!ATTLIST WebService id CDATA #REQUIRED" & Chr(13)
cadena = cadena & "                        ref CDATA #IMPLIED>" & Chr(13)
cadena = cadena & "  <!ATTLIST WebServiceConnection wsdlfile CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        wsmlfile CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        Port CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        Service CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        ref CDATA #IMPLIED>" & Chr(13)
cadena = cadena & "  <!ATTLIST WebServiceContainer targetPROGID CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        iid CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        ref CDATA #IMPLIED>" & Chr(13)
cadena = cadena & "  <!ATTLIST WebServiceTypes ref CDATA #IMPLIED>" & Chr(13)
cadena = cadena & "  <!ATTLIST WebServiceType id CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        targetNamespace CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        targetPROGID CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        iid CDATA #IMPLIED" & Chr(13)
cadena = cadena & "                        ref CDATA #IMPLIED>" & Chr(13)
cadena = cadena & "]>" & Chr(13)
cadena = cadena & "<WebServices>" & Chr(13)
cadena = cadena & "  <WebServiceGlobalTypes />" & Chr(13)
cadena = cadena & "</WebServices>" & Chr(13)
Me.LoadXml cadena

End Sub
Public Function NewType(iid As String, targetPROGID As String, Name As String, targetNameSpace As String) As WSTypeInfo

If current Is Nothing Then Exit Function
Dim TypeInfo As New WSTypeInfo

Set TypeInfo.base = current.Create("WebServiceType", Array("iid", "targetPROGID", "Name", "targetNamespace"), Array(iid, targetPROGID, Name, targetNameSpace))
Set NewType = TypeInfo
Set TypeInfo = Nothing

End Function
Public Function NewContainer(Name As String, ContainerClass As WSClassInfo, Connection As WSConnection, LocalTypes As WSTypesInfo) As WSContainerInfo

If current Is Nothing Or ContainerClass Is Nothing Or Connection Is Nothing Then Exit Function
Dim myContainer As New WSContainerInfo

Set myContainer.base = current.Create("WebService", Array("id"), Array(Name))
If Me.NewClass(ContainerClass.iid, ContainerClass.targetPROGID).base.Append(myContainer.base) Then
    If Connection.base.Append(myContainer.base) Then
        If LocalTypes Is Nothing Then
            LocalTypes = New WSTypesInfo
            Set LocalTypes.base = current.Create("WebServiceTypes", Null, Null)
        End If
        If LocalTypes.base.Append(myContainer.base) Then
            Set NewContainer = myContainer
        End If
    End If
End If
Set myContainer = Nothing

End Function
Public Function NewReference(Referenciable As IWSReferenciableInfo, Optional Name As String = "") As IWSReferenciableInfo

If Not Referenciable Is Nothing Then Set NewReference = Referenciable.createReference(Name)
    
End Function
Public Function NewClass(iid As String, targetPROGID As String) As WSClassInfo

If current Is Nothing Then Exit Function
Dim ClassInfo As New WSClassInfo

Set ClassInfo.base = current.Create("WebServiceContainer", Array("iid", "targetPROGID"), Array(iid, targetPROGID))
Set NewClass = ClassInfo
Set ClassInfo = Nothing

End Function
Public Function NewName() As WSNameInfo

If current Is Nothing Then Exit Function

End Function
Public Function NewConnection(wsdlfile As String, Service As String, Port As String, wsmlfile As String) As WSConnection

If current Is Nothing Then Exit Function
Dim Connection As New WSConnection

Set Connection.base = current.Create("WebServiceConnection", Array("wsdlfile", "Service", "Port", "wsmlfile"), Array(wsdlfile, Service, Port, wsmlfile))
Set NewConnection = Connection
Set Connection = Nothing

End Function
Public Function ExistContainerInfo(WebService As String) As Boolean

If current Is Nothing Then Exit Function
ExistContainerInfo = Not current.Count("/WebServices/WebService[@id='" & WebService & "']") = 0

End Function
Public Function WebServiceContainer(WebService As Variant) As WebServices.IWebServiceContainer

Dim ServiceContainer As WebServices.IWebServiceContainer
Dim WebServiceProxi As WebServices.IWebServiceProxi
Dim ContainerInfo As WSContainerInfo
Dim Connection As WSConnection

On Error GoTo t
If current Is Nothing Then Exit Function
Set ContainerInfo = Me.ContainerInfo(WebService)
If Not ContainerInfo Is Nothing Then
    If Not ContainerInfo.ContainerClass Is Nothing Then
       Set ServiceContainer = CreateObject(ContainerInfo.ContainerClass.targetPROGID)
       Set Connection = ContainerInfo.Connection
       If Not Connection Is Nothing And Not ServiceContainer Is Nothing Then
            Set WebServiceProxi = ServiceContainer.WebServiceProxi
            If Not WebServiceProxi Is Nothing Then
                WebServiceProxi.Initialize Connection.wsdlfile, Connection.Service, Connection.Port, Connection.wsmlfile
                If WebServiceProxi.IsAvailable Then
                   If Not Me.GlobalTypes.AddCustomTypesToProxi(WebServiceProxi) Then
                       WebServiceProxi.Terminate
                       Set ServiceContainer = Nothing
                   End If
                   If Not ContainerInfo.LocalTypes.AddCustomTypesToProxi(WebServiceProxi) Then
                       WebServiceProxi.Terminate
                       Set ServiceContainer = Nothing
                   End If
                End If
             End If
        End If
       Set WebServiceContainer = ServiceContainer
    End If
End If
t:
    Set Connection = Nothing
    Set ContainerInfo = Nothing
    Set WebServiceProxi = Nothing
    Set ServiceContainer = Nothing

End Function
Private Sub Class_Initialize()

Set current = Nothing

End Sub
Private Sub Class_Terminate()

Set current = Nothing

End Sub
