Attribute VB_Name = "WSInfoHelper"
Option Explicit

Public Sub SetAttribute(current As MSXML2.IXMLDOMNode, AttributeName As Variant, AttributeValue As String, Create As Boolean)

Dim XMLDOMAttribute As MSXML2.IXMLDOMAttribute

On Error Resume Next
If Not current Is Nothing And TypeName(AttributeName) = "String" Then Set XMLDOMAttribute = current.Attributes.getNamedItem(AttributeName)
If Not current Is Nothing And TypeName(AttributeName) = "Integer" Then XMLDOMAttribute = current.Attributes.Item(AttributeName)
If XMLDOMAttribute Is Nothing And Create Then
    Set XMLDOMAttribute = ownerDocument(current).createAttribute(AttributeName)
    current.Attributes.setNamedItem XMLDOMAttribute
End If
If Not XMLDOMAttribute Is Nothing Then XMLDOMAttribute.nodeValue = AttributeValue
Set XMLDOMAttribute = Nothing

End Sub
Public Function GetAttribute(node As MSXML2.IXMLDOMNode, AttributeName As Variant) As String

On Error Resume Next
If Not node Is Nothing And TypeName(AttributeName) = "String" Then GetAttribute = node.Attributes.getNamedItem(AttributeName).nodeValue
If Not node Is Nothing And TypeName(AttributeName) = "Integer" Then GetAttribute = node.Attributes.Item(AttributeName).nodeValue

End Function
Function QueryItem(base As IWSBaseInfo) As IWSBaseInfo

If Not base.Value("ref") = "" Then
    Set QueryItem = base.Item("/WebServices/WebService[@id='" & base.Value("ref") & "']" & IIf(Not base.Name = "WebService", "//" & base.Name, ""))
Else
    Set QueryItem = base
End If

End Function
Public Function TeElements(val As Variant) As Boolean

On Error Resume Next
TeElements = UBound(val) - LBound(val) + 1 > 0

End Function
Public Function GetElement(val As Variant, index As Integer) As Variant

On Error Resume Next
If IsObject(val(index)) Then
    Set GetElement = val(index)
Else
    GetElement = val(index)
End If

End Function
Public Function CastVariant(val As Variant) As Variant

If IsObject(val) Then
    Set CastVariant = val
Else
    CastVariant = val
End If

End Function
Public Function ownerDocument(current As MSXML2.IXMLDOMNode) As MSXML2.IXMLDOMDocument

If TypeOf current Is MSXML2.IXMLDOMDocument Then
    Set ownerDocument = current
Else
    Set ownerDocument = current.ownerDocument
End If

End Function
Public Function GetEnumName(objTypeLibInfo As TLI.TypeLibInfo, EnumValue As Long, enumName As String, defaultValue As String) As String

On Error GoTo Error_GetEnumName

Dim oTL As TypeInfo
Dim oTLMember As MemberInfo

GetEnumName = defaultValue
For Each oTL In objTypeLibInfo.TypeInfos
    If oTL.TypeKind = TKIND_ENUM And oTL.Name = enumName Then
        For Each oTLMember In oTL.Members
            If oTLMember.Value = EnumValue Then
                GetEnumName = oTLMember.Name
                Exit Function
            End If
        Next oTLMember
    End If
Next oTL

Exit Function

Error_GetEnumName:

GetEnumName = "Error"

End Function
Public Function GetEnumValue(objTypeLibInfo As TLI.TypeLibInfo, enumName As String, enumValueName As String, defaultValue As Integer) As Integer

On Error GoTo Error_GetEnumName

Dim oTL As TypeInfo
Dim oTLMember As MemberInfo

GetEnumValue = defaultValue
For Each oTL In objTypeLibInfo.TypeInfos
    If oTL.TypeKind = TKIND_ENUM And oTL.Name = enumName Then
        For Each oTLMember In oTL.Members
            If oTLMember.Name = enumValueName Then
                GetEnumValue = oTLMember.Value
                Exit Function
            End If
        Next oTLMember
    End If
Next oTL

Error_GetEnumName:


End Function

