Attribute VB_Name = "helper"
Option Explicit
Public Function HiHaErrorServer(ret As SoapParser.ReturnValue) As Boolean

On Error Resume Next

If ret.isObject Then If Not ret.value Is Nothing Then HiHaErrorServer = TypeOf ret.value Is SoapParser.SoapError
Err.Clear

End Function
Public Function GetFaultCodeSoapClient(SoapClient As MSSOAPLib30.SoapClient30) As String

If Not SoapClient Is Nothing Then GetFaultCodeSoapClient = SoapClient.FaultCode

End Function
Public Function GetFaultCode(WebServiceError As SoapParser.SoapError) As String

If Not WebServiceError Is Nothing Then GetFaultCode = WebServiceError.FaultCode

End Function
Public Sub ResolverErrorHandler(str_Function As String, WebServiceError As SoapParser.SoapError, SoapClient As MSSOAPLib30.SoapClient30)

If Not Err.Number = 0 Then
    Err.Raise Err.Number, str_Function, Err.Description
ElseIf Not GetFaultCodeSoapClient(SoapClient) = "" Then
    Err.Raise vbObjectError, str_Function, SoapClient.FaultString
ElseIf Not GetFaultCode(WebServiceError) = "" Then
    Err.Raise vbObjectError, str_Function, WebServiceError.FaultString
End If

End Sub

Public Function TeElements(matriu As Variant) As Boolean

On Error Resume Next
TeElements = IsArray(matriu) And (UBound(matriu) - LBound(matriu) + 1 > 0)

End Function
Public Function ExistType(TypeFactory As MSSOAPLib30.SoapTypeMapperFactory30, par_TypeName As String, par_TypeNamespace As String) As Boolean

On Error Resume Next
If Not TypeFactory Is Nothing Then ExistType = TypeFactory.GetTypeMapperByName(par_TypeName, par_TypeNamespace) Is Nothing

End Function
Public Function GetTypeMapper(pSoapTypeMapperFactory As MSSOAPLib30.SoapTypeMapperFactory30, TypeName As String, par_SchemaNode As IXMLDOMNode) As MSSOAPLib30.ISoapTypeMapper

Select Case TypeName
       Case "SoapError"
            If Not pSoapTypeMapperFactory Is Nothing Then Set GetTypeMapper = New SoapParser.SoapErrorTypeMapper
       Case Else
            If Not pSoapTypeMapperFactory Is Nothing Then Set GetTypeMapper = pSoapTypeMapperFactory.GetMapper(GetEnumValue(tli.TLIApplication.InterfaceInfoFromObject(pSoapTypeMapperFactory).Parent, "enXSDType", TypeName, enXSDUndefined), par_SchemaNode)
End Select

End Function
Public Function GetNode(ByVal SoapReader As MSSOAPLib30.ISoapReader, XMLDOMNode As MSXML2.IXMLDOMNode) As MSXML2.IXMLDOMNode

If Not XMLDOMNode Is Nothing Then
    If SoapReader.IsNodeReference(XMLDOMNode) Then
        Set GetNode = SoapReader.GetReferencedNode(XMLDOMNode)
    ElseIf SoapReader.IsAttachmentReference(XMLDOMNode) Then
        Set GetNode = SoapReader.GetReferencedAttachment(XMLDOMNode)
    Else
        Set GetNode = XMLDOMNode
    End If
End If

End Function
Public Function GetNodeName(ByVal SoapReader As MSSOAPLib30.ISoapReader, XMLDOMNode As MSXML2.IXMLDOMNode, Name As String) As MSXML2.IXMLDOMNode

If Not XMLDOMNode Is Nothing Then Set GetNodeName = GetNode(SoapReader, XMLDOMNode.selectSingleNode(Name))

End Function
Public Function GetEnumName(EnumValue As Long, enumName As String, TypeLibOrigen As String) As String

On Error GoTo Error_GetEnumName

Dim oTLIApp As New tli.TLIApplication
Dim oTLI As TypeLibInfo
Dim oTL As TypeInfo
Dim oTLMember As MemberInfo

GetEnumName = "???"
Set oTLI = oTLIApp.TypeLibInfoFromFile(TypeLibOrigen)
For Each oTL In oTLI.TypeInfos
    If oTL.TypeKind = TKIND_ENUM And oTL.Name = enumName Then
        '  Now we have to search each member to find the correct value.
        For Each oTLMember In oTL.Members
            If oTLMember.value = EnumValue Then
                GetEnumName = oTLMember.Name
                Exit Function
            End If
        Next oTLMember
    End If
Next oTL

Exit Function

Error_GetEnumName:

GetEnumName = "Error"

End Function
Public Function GetEnumValue(objTypeLibInfo As tli.TypeLibInfo, enumName As String, enumValueName As String, defaultValue As Integer) As Integer

    Dim objMemberInfo As tli.MemberInfo

    On Error Resume Next
    GetEnumValue = defaultValue
    Set objMemberInfo = objTypeLibInfo.TypeInfos.NamedItem(enumName).GetMember(enumValueName)
    GetEnumValue = objMemberInfo.value
    Set objMemberInfo = Nothing

End Function
Public Function GetElement(matriu As Variant, Index As Integer) As Variant

On Error Resume Next
If isObject(matriu(Index)) Then
   Set GetElement = matriu(Index)
Else
   GetElement = matriu(Index)
End If

End Function
Public Function CreateArrayType(ThisIsObject As Boolean) As Variant

Dim CreateArray() As Variant
Dim CreateArrayObject() As Object

If ThisIsObject Then
    CreateArrayType = CreateArrayObject
Else
    CreateArrayType = CreateArray
End If

End Function
Public Function GetValue(llista As Collection, Name As String) As Variant

Dim val As ReturnValue
    
    If ExisteixKey(llista, Name) Then
        Set val = llista(Name)
        If val.isObject Then
           Set GetValue = val.value
        Else
           GetValue = val.value
        End If
     End If
     Set val = Nothing

End Function
Public Function ExisteixKey(llista As Collection, key As String) As Boolean

Dim val As Variant

On Error Resume Next
If isObject(llista(key)) Then
    ExisteixKey = Not llista(key) Is Nothing
Else
    ExisteixKey = Not IsNull(llista(key))
End If

End Function
Public Function GetNameSpace(node As MSXML2.IXMLDOMDocument, Name As Variant) As String

If Not node Is Nothing And TypeName(Name) = "String" Then GetNameSpace = node.documentElement.Attributes.getNamedItem("xmlns:" & Name).nodeValue
If Not node Is Nothing And TypeName(Name) = "Integer" Then GetNameSpace = node.documentElement.Attributes.Item(Name).nodeValue

End Function

Public Function GetAttribute(node As MSXML2.IXMLDOMNode, AttributeName As Variant) As String

On Error Resume Next
If Not node Is Nothing And TypeName(AttributeName) = "String" Then GetAttribute = node.Attributes.getNamedItem(AttributeName).nodeValue
If Not node Is Nothing And TypeName(AttributeName) = "Integer" Then GetAttribute = node.Attributes.Item(AttributeName).nodeValue

End Function
Public Function IsSympleType(element As Variant) As Boolean

IsSympleType = True
On Error Resume Next
If Not IsArray(element) Then
'   IsSympleType = Not isObject(element(LBound(element)))
'Else
    IsSympleType = Not isObject(element)
End If

End Function
