using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace PhSystems.Twain
{

	[Flags]
	internal	enum TwDG : short
	{									// DG_.....
		Control			= 0x0001,
		Image			= 0x0002,
		Audio			= 0x0004
	}

	internal	enum TwDAT : short
	{									// DAT_....
		Null			= 0x0000,
		Capability		= 0x0001,
		Event			= 0x0002,
		Identity		= 0x0003,
		Parent			= 0x0004,
		PendingXfers	= 0x0005,
		SetupMemXfer	= 0x0006,
		SetupFileXfer	= 0x0007,
		Status			= 0x0008,
		UserInterface	= 0x0009,
		XferGroup		= 0x000a,
		TwunkIdentity	= 0x000b,
		CustomDSData	= 0x000c,
		DeviceEvent		= 0x000d,
		FileSystem		= 0x000e,
		PassThru		= 0x000f,

		ImageInfo		= 0x0101,
		ImageLayout		= 0x0102,
		ImageMemXfer	= 0x0103,
		ImageNativeXfer	= 0x0104,
		ImageFileXfer	= 0x0105,
		CieColor		= 0x0106,
		GrayResponse	= 0x0107,
		RGBResponse		= 0x0108,
		JpegCompression	= 0x0109,
		Palette8		= 0x010a,
		ExtImageInfo	= 0x010b,

		SetupFileXfer2	= 0x0301
	}

	internal	enum TwProp : short
	{
		Get				= 0x0001,
		Set				= 0x0006
	}

	internal	enum TwType : short
	{									// TWTY_....
		Int8			= 0x0000,
		Int16			= 0x0001,
		Int32			= 0x0002,
		UInt8			= 0x0003,
		UInt16			= 0x0004,
		UInt32			= 0x0005,
		Bool			= 0x0006,
		Fix32			= 0x0007,
		Frame			= 0x0008,
		Str32			= 0x0009,
		Str64			= 0x000a,
		Str128			= 0x000b,
		Str255			= 0x000c,
		Str1024			= 0x000d,
		Str512			= 0x000e
	}
	
	internal	enum TwQC:short
	{
		GET           =0x0001, 
		SET           =0x0002,
		GETDEFAULT    =0x0004,
		GETCURRENT    =0x0008,
		RESET         =0x0010
	}
	internal	enum TwEI:short
	{
		BARCODEX               =0x1200,
		BARCODEY               =0x1201,
		BARCODETEXT            =0x1202,
		BARCODETYPE            =0x1203,
		DESHADETOP             =0x1204,
		DESHADELEFT            =0x1205,
		DESHADEHEIGHT          =0x1206,
		DESHADEWIDTH           =0x1207,
		DESHADESIZE            =0x1208,
		SPECKLESREMOVED        =0x1209,
		HORZLINEXCOORD         =0x120A,
		HORZLINEYCOORD         =0x120B,
		HORZLINELENGTH         =0x120C,
		HORZLINETHICKNESS      =0x120D,
		VERTLINEXCOORD         =0x120E,
		VERTLINEYCOORD         =0x120F,
		VERTLINELENGTH         =0x1210,
		VERTLINETHICKNESS      =0x1211,
		PATCHCODE              =0x1212,
		ENDORSEDTEXT           =0x1213,
		FORMCONFIDENCE         =0x1214,
		FORMTEMPLATEMATCH      =0x1215,
		FORMTEMPLATEPAGEMATCH  =0x1216,
		FORMHORZDOCOFFSET      =0x1217,
		FORMVERTDOCOFFSET      =0x1218,
		BARCODECOUNT           =0x1219,
		BARCODECONFIDENCE      =0x121A,
		BARCODEROTATION        =0x121B,
		BARCODETEXTLENGTH      =0x121C,
		DESHADECOUNT           =0x121D,
		DESHADEBLACKCOUNTOLD   =0x121E,
		DESHADEBLACKCOUNTNEW   =0x121F,
		DESHADEBLACKRLMIN      =0x1220,
		DESHADEBLACKRLMAX      =0x1221,
		DESHADEWHITECOUNTOLD   =0x1222,
		DESHADEWHITECOUNTNEW   =0x1223,
		DESHADEWHITERLMIN      =0x1224,
		DESHADEWHITERLAVE      =0x1225,
		DESHADEWHITERLMAX      =0x1226,
		BLACKSPECKLESREMOVED   =0x1227,
		WHITESPECKLESREMOVED   =0x1228,
		HORZLINECOUNT          =0x1229,
		VERTLINECOUNT          =0x122A,
		DESKEWSTATUS           =0x122B,
		SKEWORIGINALANGLE      =0x122C,
		SKEWFINALANGLE         =0x122D,
		SKEWCONFIDENCE         =0x122E,
		SKEWWINDOWX1           =0x122F,
		SKEWWINDOWY1           =0x1230,
		SKEWWINDOWX2           =0x1231,
		SKEWWINDOWY2           =0x1232,
		SKEWWINDOWX3           =0x1233,
		SKEWWINDOWY3           =0x1234,
		SKEWWINDOWX4           =0x1235,
		SKEWWINDOWY4           =0x1236
	}

	internal	enum TwEJ:short
	{
		NONE                   =0x0000,
		MIDSEPARATOR           =0x0001,
		PATCH1                 =0x0002,
		PATCH2                 =0x0003,
		PATCH3                 =0x0004,
		PATCH4                 =0x0005,
		PATCH6                 =0x0006,
		PATCHT                 =0x0007
	}

	internal	enum TwGMEM :int
	{
		FIXED          =0x0000,
		MOVEABLE       =0x0002,
		NOCOMPACT      =0x0010,
		NODISCARD      =0x0020,
		ZEROINIT       =0x0040,
		MODIFY         =0x0080,
		DISCARDABLE    =0x0100,
		NOT_BANKED     =0x1000,
		SHARE          =0x2000,
		DDESHARE       =0x2000,
		NOTIFY         =0x4000,
		LOWER          =NOT_BANKED,
		VALID_FLAGS    =0x7F72,
		INVALID_HANDLE =0x8000,
		DISCARDED      =0x4000,
		LOCKCOUNT      =0x00FF
	}

	
	/* Flags used in TW_MEMORY structure. */
	internal	enum TwMF:short
	{
		APPOWNS     =0x1,
		DSMOWNS     =0x2,
		DSOWNS      =0x4,
		POINTER     =0x8,
		HANDLE      =0x10
	}

	/* Palette types for TW_PALETTE8 */
	internal	enum TwPA:short
	{
		RGB         =0,
		GRAY        =1,
		CMY         =2
	}


	public		enum TwCC : short
	{									// TWCC_....
		Success				= 0x0000,
		Bummer				= 0x0001,
		LowMemory			= 0x0002,
		NoDS				= 0x0003,
		MaxConnections		= 0x0004,
		OperationError		= 0x0005,
		BadCap				= 0x0006,
		BadProtocol			= 0x0009,
		BadValue			= 0x000a,
		SeqError			= 0x000b,
		BadDest				= 0x000c,
		CapUnsupported		= 0x000d,
		CapBadOperation		= 0x000e,
		CapSeqError			= 0x000f,
		Denied				= 0x0010,
		FileExists			= 0x0011,
		FileNotFound		= 0x0012,
		NotEmpty			= 0x0013,
		PaperJam			= 0x0014,
		PaperDoubleFeed		= 0x0015,
		FileWriteError		= 0x0016,
		CheckDeviceOnline	= 0x0017
	}

	public		enum TwOn : short
	{									// TWON_....
		Array			= 0x0003,
		Enum			= 0x0004,
		One				= 0x0005,
		Range			= 0x0006,
		DontCare		= -1
	}

	public		enum TwOperation:short
	{
		AudioFileXferGet=0,//		                                DG_AUDIO   / DAT_AUDIOFILEXFER   / MSG_GET 
		AudioInfoGet    =1,//                                    	DG_AUDIO   / DAT_AUDIOINFO 		 / MSG_GET 
		AudioNativeXferGet   =2,//                                 DG_AUDIO   / DAT_AUDIONATIVEXFER / MSG_GET 
		CapabilityGet       =3,//                                 	DG_CONTROL / DAT_CAPABILITY  	 / MSG_GET 
		CapabilityGetCurrent     =4,//                             DG_CONTROL / DAT_CAPABILITY 	 / MSG_GETCURRENT 
		CapabilityGetDefault  =5,//                                DG_CONTROL / DAT_CAPABILITY 	 / MSG_GETDEFAULT 
		CapabilityQuerySupport =6,//                               DG_CONTROL / DAT_CAPABILITY  	 / MSG_QUERYSUPPORT 
		CapabilityReset       =7,//                               	DG_CONTROL / DAT_CAPABILITY 	 / MSG_RESET 
		CapabilitySet        =8,//                                	DG_CONTROL / DAT_CAPABILITY 	 / MSG_SET 
		CieColorGet           =9,//                             	DG_IMAGE   / DAT_CIECOLOR 		 / MSG_GET 
		CustomDSDataGet      =10,//                                 DG_CONTROL / DAT_CUSTOMDSDATA 	 / MSG_GET 
		CustomDSDataSet      =11,//                                 DG_CONTROL / DAT_CUSTOMDSDATA    / MSG_SET 
		DeviceEventGet        =12,//                                DG_CONTROL / DAT_DEVICEEVENT 	 / MSG_GET 
		EventProcessEvent   =13,//                                  DG_CONTROL / DAT_EVENT 			 / MSG_PROCESSEVENT 
		ExtImageInfoGet       =14,//                                DG_IMAGE   / DAT_EXTIMAGEINFO 	 / MSG_GET 
		FileSystemAutomaticCaptureDirectory 	=15,//				DG_CONTROL / DAT_FILESYSTEM 	 / MSG_AUTOMATICCAPTUREDIRECTORY 
		FileSystemChangeDirectory 	=16,//						DG_CONTROL / DAT_FILESYSTEM 	 / MSG_CHANGEDIRECTORY 
		FileSystemCopy 			=17,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_COPY 
		FileSystemCreateDirectory =18,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_CREATEDIRECTORY 
		FileSystemDelete 		=19,//								DG_CONTROL / DAT_FILESYSTEM 	 / MSG_DELETE 
		FileSystemFormatMedia 	=20,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_FORMATMEDIA 
		FileSystemGetClose 		=21,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_GETCLOSE 
		FileSystemGetFirstFile 	=22,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_GETFIRSTFILE 
		FileSystemGetInfo 		=23,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_GETINFO 
		FileSystemGetNextFile 	=24,//							DG_CONTROL / DAT_FILESYSTEM 	 / MSG_GETNEXTFILE 
		FileSystemRename 		=25,//								DG_CONTROL / DAT_FILESYSTEM 	 / MSG_RENAME 
		GrayscaleResponseReset  =26,//                              DG_IMAGE   / DAT_GRAYRESPONSE 	 / MSG_RESET 
		GrayscaleResponseSet    =27,//                              DG_IMAGE   / DAT_GRAYRESPONSE 	 / MSG_SET 
		IdentityCloseDS 		=28,//								DG_CONTROL / DAT_IDENTITY 		 / MSG_CLOSEDS 
		IdentityGetDefault    =29,//                                DG_CONTROL / DAT_IDENTITY 		 / MSG_GETDEFAULT 
		IdentityGetFirst     =30,//                                 DG_CONTROL / DAT_IDENTITY 		 / MSG_GETFIRST 
		IdentityGetNext     =31,//                                  DG_CONTROL / DAT_IDENTITY 		 / MSG_GETNEXT 
		IdentityOpenDS 		=32,//								DG_CONTROL / DAT_IDENTITY 		 / MSG_OPENDS 
		IdentityUserSelect    =33,//                                DG_CONTROL / DAT_IDENTITY 		 / MSG_USERSELECT 
		ImageFileXferGet      =34,//                                DG_IMAGE   / DAT_IMAGEFILEXFER 	 / MSG_GET 
		ImageInfoGet      	=35,//                                DG_IMAGE   / DAT_IMAGEINFO 		 / MSG_GET 
		ImageLayoutGet    	 =36,//                               DG_IMAGE   / DAT_IMAGELAYOUT 	 / MSG_GET 
		ImageLayoutGetDefault =37,//                                DG_IMAGE   / DAT_IMAGELAYOUT 	 / MSG_GETDEFAULT 
		ImageLayoutReset   =38,//                                   DG_IMAGE   / DAT_IMAGELAYOUT 	 / MSG_RESET 
		ImageLayoutSet     =39,//                                   DG_IMAGE   / DAT_IMAGELAYOUT 	 / MSG_SET 
		ImageMemXferGet     =40,//                                  DG_IMAGE   / DAT_IMAGEMEMXFER 	 / MSG_GET 
		ImageNativeXferGet  =41,//                                  DG_IMAGE   / DAT_IMAGENATIVEXFER / MSG_GET 
		JpegCompressionGet   =42,//                                 DG_IMAGE   / DAT_JPEGCOMPRESSION / MSG_GET 
		JpegCompressionGetDefault  =43,//                           DG_IMAGE   / DAT_JPEGCOMPRESSION / MSG_GETDEFAULT 
		JpegCompressionReset  =44,//                                DG_IMAGE   / DAT_JPEGCOMPRESSION / MSG_RESET 
		JpegCompressionSet  =45,//                                  DG_IMAGE   / DAT_JPEGCOMPRESSION / MSG_SET 
		NullCloseDSReq 		=46,//								DG_CONTROL / DAT_NULL 			 / MSG_CLOSEDSREQ 
		NullDeviceEvent  =47,//                                     DG_CONTROL / DAT_NULL  			 / MSG_DEVICEEVENT 
		NullXferReady 	=48,//									DG_CONTROL / DAT_NULL 			 / MSG_XFERREADY 
		Palette8Get      =49,//                                  	DG_IMAGE   / DAT_PALETTE8 		 / MSG_GET 
		Palette8GetDefault  =50,//                                  DG_IMAGE   / DAT_PALETTE8 		 / MSG_GETDEFAULT 
		Palette8Reset     =51,//                                    DG_IMAGE   / DAT_PALETTE8 		 / MSG_RESET 
		Palette8Set     =52,//             	                        DG_IMAGE   / DAT_PALETTE8 		 / MSG_SET 
		PassThru 		=53,//										DG_CONTROL / DAT_PASSTHRU 		 / MSG_PASSTHRU 
		PendingXfersEndXfer =54,//									DG_CONTROL / DAT_PENDINGXFERS 	 / MSG_ENDXFER 
		PendingXfersGet      =55,//                                 DG_CONTROL / DAT_PENDINGXFERS 	 / MSG_GET 
		PendingXfersReset      =56,//                               DG_CONTROL / DAT_PENDINGXFERS 	 / MSG_RESET 
		PendingXfersStopFeeder 	=57,//							DG_CONTROL / DAT_PENDINGXFERS 	 / MSG_STOPFEEDER 
		RgbResponseReset   =58,//                                   DG_IMAGE   / DAT_RGBRESPONSE 	 / MSG_RESET 
		RgbResponseSet    =59,//                                    DG_IMAGE   / DAT_RGBRESPONSE 	 / MSG_SET 
		SetupFileXferGet     =60,//                                 DG_CONTROL / DAT_SETUPFILEXFER 	 / MSG_GET 
		SetupFileXferGetDefault   =61,//                            DG_CONTROL / DAT_SETUPFILEXFER 	 / MSG_GETDEFAULT 
		SetupFileXFerReset   =62,//                                 DG_CONTROL / DAT_SETUPFILEXFER 	 / MSG_RESET 
		SetupFileXFerSet    =63,//                                  DG_CONTROL / DAT_SETUPFILEXFER 	 / MSG_SET 
		SetupFileXfer2Get   =64,//                                  DG_CONTROL / DAT_SETUPFILEXFER2	 / MSG_GET 
		SetupFileXfer2GetDefault    =65,//                          DG_CONTROL / DAT_SETUPFILEXFER2  / MSG_GETDEFAULT 
		SetupFileXfer2Reset =66,//                                  DG_CONTROL / DAT_SETUPFILEXFER2  / MSG_RESET 
		SetupFileXfer2Set   =67,//                                  DG_CONTROL / DAT_SETUPFILEXFER2  / MSG_SET 
		SetupMemXFerGet   =68,//                                    DG_CONTROL / DAT_SETUPMEMXFER 	 / MSG_GET 
		StatusGet         =69,//            						DG_CONTROL / DAT_STATUS 		 / MSG_GET 
		UserInterfaceDisableDS 	=70,//							DG_CONTROL / DAT_USERINTERFACE 	 / MSG_DISABLEDS 
		UserInterfaceEnableDS 	=71,//							DG_CONTROL / DAT_USERINTERFACE 	 / MSG_ENABLEDS 
		UserInterfaceEnableDSUIOnly =72,//							DG_CONTROL / DAT_USERINTERFACE 	 / MSG_ENABLEDSUIONLY 
		XferGroupGet   =73,//                                       DG_CONTROL / DAT_XFERGROUP 		 / MSG_GET 
		XferGroupSet   =74//                                       DG_CONTROL / DAT_XFERGROUP 		 / MSG_SET 
	}

	public		enum TwRC : short
	{									// TWRC_....
		Success				= 0x0000,
		Failure				= 0x0001,
		CheckStatus			= 0x0002,
		Cancel				= 0x0003,
		DSEvent				= 0x0004,
		NotDSEvent			= 0x0005,
		XferDone			= 0x0006,
		EndOfList			= 0x0007,
		InfoNotSupported	= 0x0008,
		DataNotAvailable	= 0x0009
	}

	public		enum TwMSG : short
	{									// MSG_.....
		Null			= 0x0000,
		Get				= 0x0001,
		GetCurrent		= 0x0002,
		GetDefault		= 0x0003,
		GetFirst		= 0x0004,
		GetNext			= 0x0005,
		Set				= 0x0006,
		Reset			= 0x0007,
		QuerySupport	= 0x0008,

		XFerReady		= 0x0101,
		CloseDSReq		= 0x0102,
		CloseDSOK		= 0x0103,
		DeviceEvent		= 0x0104,

		CheckStatus		= 0x0201,

		OpenDSM			= 0x0301,
		CloseDSM		= 0x0302,

		OpenDS			= 0x0401,
		CloseDS			= 0x0402,
		UserSelect		= 0x0403,

		DisableDS		= 0x0501,
		EnableDS		= 0x0502,
		EnableDSUIOnly	= 0x0503,

		ProcessEvent	= 0x0601,

		EndXfer			= 0x0701,
		StopFeeder		= 0x0702,

		ChangeDirectory	= 0x0801,
		CreateDirectory	= 0x0802,
		Delete			= 0x0803,
		FormatMedia		= 0x0804,
		GetClose		= 0x0805,
		GetFirstFile	= 0x0806,
		GetInfo			= 0x0807,
		GetNextFile		= 0x0808,
		Rename			= 0x0809,
		Copy			= 0x080A,
		AutoCaptureDir	= 0x080B,

		PassThru		= 0x0901
	}

	public		enum TwCap : short
	{
		//CUSTOMBASE					  =0x8000, /* Base of custom capabilities */
		XFERCOUNT					  =0x0001,
		ICOMPRESSION				  =0x0100,
		IPIXELTYPE					  =0x0101,
		IUNITS						  =0x0102,   /* default is TWUN_INCHES */
		IXFERMECH					  =0x0103,
		AUTHOR						  =0x1000,
		CAPTION						  =0x1001,
		FEEDERENABLED				  =0x1002,
		FEEDERLOADED				  =0x1003,
		TIMEDATE					  =0x1004,
		SUPPORTEDCAPS				  =0x1005,
		EXTENDEDCAPS				  =0x1006,
		AUTOFEED					  =0x1007,
		CLEARPAGE					  =0x1008,
		FEEDPAGE					  =0x1009,
		REWINDPAGE					  =0x100a,
		INDICATORS					  =0x100b,   /* Added 1.1 */
		SUPPORTEDCAPSEXT			  =0x100c,   /* Added 1.6 */
		PAPERDETECTABLE				  =0x100d,   /* Added 1.6 */
		UICONTROLLABLE				  =0x100e,   /* Added 1.6 */
		DEVICEONLINE				  =0x100f,   /* Added 1.6 */
		AUTOSCAN					  =0x1010,   /* Added 1.6 */
		THUMBNAILSENABLED			  =0x1011,   /* Added 1.7 */
		DUPLEX						  =0x1012,   /* Added 1.7 */
		DUPLEXENABLED				  =0x1013,   /* Added 1.7 */
		ENABLEDSUIONLY				  =0x1014,   /* Added 1.7 */
		CUSTOMDSDATA				  =0x1015,   /* Added 1.7 */
		ENDORSER					  =0x1016,   /* Added 1.7 */
		JOBCONTROL					  =0x1017,   /* Added 1.7 */
		ALARMS						  =0x1018,   /* Added 1.8 */
		ALARMVOLUME					  =0x1019,   /* Added 1.8 */
		AUTOMATICCAPTURE			  =0x101a,   /* Added 1.8 */
		TIMEBEFOREFIRSTCAPTURE		  =0x101b,   /* Added 1.8 */
		TIMEBETWEENCAPTURES			  =0x101c,   /* Added 1.8 */
		CLEARBUFFERS				  =0x101d,   /* Added 1.8 */
		MAXBATCHBUFFERS				  =0x101e,   /* Added 1.8 */
		DEVICETIMEDATE				  =0x101f,   /* Added 1.8 */
		POWERSUPPLY					  =0x1020,   /* Added 1.8 */
		CAMERAPREVIEWUI				  =0x1021,   /* Added 1.8 */
		DEVICEEVENT					  =0x1022,   /* Added 1.8 */
		PAGEMULTIPLEACQUIRE			  =0x1023,   /* Added 1.8 */
		SERIALNUMBER				  =0x1024,   /* Added 1.8 */
		FILESYSTEM					  =0x1025,   /* Added 1.8 */
		PRINTER						  =0x1026,   /* Added 1.8 */
		PRINTERENABLED				  =0x1027,   /* Added 1.8 */
		PRINTERINDEX				  =0x1028,   /* Added 1.8 */
		PRINTERMODE					  =0x1029,   /* Added 1.8 */
		PRINTERSTRING				  =0x102a,   /* Added 1.8 */
		PRINTERSUFFIX				  =0x102b,   /* Added 1.8 */
		LANGUAGE					  =0x102c,   /* Added 1.8 */
		FEEDERALIGNMENT				  =0x102d,   /* Added 1.8 */
		FEEDERORDER					  =0x102e,   /* Added 1.8 */
		PAPERBINDING				  =0x102f,   /* Added 1.8 */
		REACQUIREALLOWED			  =0x1030,   /* Added 1.8 */
		PASSTHRU					  =0x1031,   /* Added 1.8 */
		BATTERYMINUTES				  =0x1032,   /* Added 1.8 */
		BATTERYPERCENTAGE	 		  =0x1033,   /* Added 1.8 */
		POWERDOWNTIME				  =0x1034,   /* Added 1.8 */
		IAUTOBRIGHT                   =0x1100,
		IBRIGHTNESS                   =0x1101,
		ICONTRAST                     =0x1103,
		ICUSTHALFTONE                 =0x1104,
		IEXPOSURETIME                 =0x1105,
		IFILTER                       =0x1106,
		IFLASHUSED                    =0x1107,
		IGAMMA                        =0x1108,
		IHALFTONES                    =0x1109,
		IHIGHLIGHT                    =0x110a,
		IIMAGEFILEFORMAT              =0x110c,
		ILAMPSTATE                    =0x110d,
		ILIGHTSOURCE                  =0x110e,
		IORIENTATION                  =0x1110,
		IPHYSICALWIDTH                =0x1111,
		IPHYSICALHEIGHT               =0x1112,
		ISHADOW                       =0x1113,
		IFRAMES                       =0x1114,
		IXNATIVERESOLUTION            =0x1116,
		IYNATIVERESOLUTION            =0x1117,
		IXRESOLUTION                  =0x1118,
		IYRESOLUTION                  =0x1119,
		IMAXFRAMES                    =0x111a,
		ITILES                        =0x111b,
		IBITORDER                     =0x111c,
		ICCITTKFACTOR                 =0x111d,
		ILIGHTPATH                    =0x111e,
		IPIXELFLAVOR                  =0x111f,
		IPLANARCHUNKY                 =0x1120,
		IROTATION                     =0x1121,
		ISUPPORTEDSIZES               =0x1122,
		ITHRESHOLD                    =0x1123,
		IXSCALING                     =0x1124,
		IYSCALING                     =0x1125,
		IBITORDERCODES                =0x1126,
		IPIXELFLAVORCODES             =0x1127,
		IJPEGPIXELTYPE                =0x1128,
		ITIMEFILL                     =0x112a,
		IBITDEPTH                     =0x112b,
		IBITDEPTHREDUCTION            =0x112c, /* Added 1.5 */
		IUNDEFINEDIMAGESIZE           =0x112d,  /* Added 1.6 */
		IIMAGEDATASET                 =0x112e,  /* Added 1.7 */
		IEXTIMAGEINFO                 =0x112f,  /* Added 1.7 */
		IMINIMUMHEIGHT                =0x1130,  /* Added 1.7 */
		IMINIMUMWIDTH                 =0x1131,  /* Added 1.7 */
		IAUTODISCARDBLANKPAGES        =0x1134,  /* Added 1.8 */
		IFLIPROTATION                 =0x1136,  /* Added 1.8 */
		IBARCODEDETECTIONENABLED      =0x1137,  /* Added 1.8 */
		ISUPPORTEDBARCODETYPES        =0x1138,  /* Added 1.8 */
		IBARCODEMAXSEARCHPRIORITIES   =0x1139,  /* Added 1.8 */
		IBARCODESEARCHPRIORITIES      =0x113a,  /* Added 1.8 */
		IBARCODESEARCHMODE            =0x113b,  /* Added 1.8 */
		IBARCODEMAXRETRIES            =0x113c,  /* Added 1.8 */
		IBARCODETIMEOUT               =0x113d,  /* Added 1.8 */
		IZOOMFACTOR                   =0x113e,  /* Added 1.8 */
		IPATCHCODEDETECTIONENABLED    =0x113f,  /* Added 1.8 */
		ISUPPORTEDPATCHCODETYPES      =0x1140,  /* Added 1.8 */
		IPATCHCODEMAXSEARCHPRIORITIES =0x1141,  /* Added 1.8 */
		IPATCHCODESEARCHPRIORITIES    =0x1142,  /* Added 1.8 */
		IPATCHCODESEARCHMODE          =0x1143,  /* Added 1.8 */
		IPATCHCODEMAXRETRIES          =0x1144,  /* Added 1.8 */
		IPATCHCODETIMEOUT             =0x1145,  /* Added 1.8 */
		IFLASHUSED2                   =0x1146,  /* Added 1.8 */
		IIMAGEFILTER                  =0x1147,  /* Added 1.8 */
		INOISEFILTER                  =0x1148,  /* Added 1.8 */
		IOVERSCAN                     =0x1149,  /* Added 1.8 */
		IAUTOMATICBORDERDETECTION     =0x1150,  /* Added 1.8 */
		IAUTOMATICDESKEW              =0x1151,  /* Added 1.8 */
		IAUTOMATICROTATE              =0x1152,  /* Added 1.8 */
		AUDIOFILEFORMAT				  =0x1201,  /* Added 1.8 */
		XFERMECH					  =0x1202  /* Added 1.8 */
	}

	public		enum TwainCommand
	{
		Not				= -1,
		Null			= 0,
		TransferReady	= 1,
		CloseRequest	= 2,
		CloseOk			= 3,
		DeviceEvent		= 4,
		Failure			= 5,
		Cancel			= 6
	}


/****************************************************************************
 * Capability Constants                                                     *
 ****************************************************************************/

	public		enum TWLG:short
	{
		DAN = 000, // Danish
		DUT = 001, // Dutch
		ENG = 002, // English
		FCF = 003, // French Canadian
		FIN = 004, // Finnish
		FRN = 005, // French
		GER = 006, // German
		ICE = 007, // Icelandic
		ITN = 008, // Italian
		NOR = 009, // Norwegian
		POR = 010, // Portuguese
		SPA = 011, // Spannish
		SWE = 012, // Swedish
		USA = 013,
		AFRIKAANS = 014,
		ALBANIA = 015,
		ARABIC = 016,
		ARABIC_ALGERIA = 017,
		ARABIC_BAHRAIN = 018,
		ARABIC_EGYPT = 019,
		ARABIC_IRAQ = 020,
		ARABIC_JORDAN = 021,
		ARABIC_KUWAIT = 022,
		ARABIC_LEBANON = 023,
		ARABIC_LIBYA = 024,
		ARABIC_MOROCCO = 025,
		ARABIC_OMAN = 026,
		ARABIC_QATAR = 027,
		ARABIC_SAUDIARABIA = 028,
		ARABIC_SYRIA = 029,
		ARABIC_TUNISIA = 030,
		ARABIC_UAE = 031, // United Arabic Emirates
		ARABIC_YEMEN = 032,
		BASQUE = 033,
		BYELORUSSIAN = 034,
		BULGARIAN = 035,
		CATALAN = 036,
		CHINESE = 037,
		CHINESE_HONGKONG = 038,
		CHINESE_PRC = 039, // People's Republic of China
		CHINESE_SINGAPORE = 040,
		CHINESE_SIMPLIFIED = 041,
		CHINESE_TAIWAN = 042,
		CHINESE_TRADITIONAL = 043,
		CROATIA = 044,
		CZECH = 045,
		DANISH = DAN,
		DUTCH = DUT,
		DUTCH_BELGIAN = 046,
		ENGLISH = ENG,
		ENGLISH_AUSTRALIAN = 047,
		ENGLISH_CANADIAN = 048,
		ENGLISH_IRELAND = 049,
		ENGLISH_NEWZEALAND = 050,
		ENGLISH_SOUTHAFRICA = 051,
		ENGLISH_UK = 052,
		ENGLISH_USA = USA,
		ESTONIAN = 053,
		FAEROESE = 054,
		FARSI = 055,
		FINNISH = FIN,
		FRENCH = FRN,
		FRENCH_BELGIAN = 056,
		FRENCH_CANADIAN = FCF,
		FRENCH_LUXEMBOURG = 057,
		FRENCH_SWISS = 058,
		GERMAN = GER,
		GERMAN_AUSTRIAN = 059,
		GERMAN_LUXEMBOURG = 060,
		GERMAN_LIECHTENSTEIN = 061,
		GERMAN_SWISS = 062,
		GREEK = 063,
		HEBREW = 064,
		HUNGARIAN = 065,
		ICELANDIC = ICE,
		INDONESIAN = 066,
		ITALIAN = ITN,
		ITALIAN_SWISS = 067,
		JAPANESE = 068,
		KOREAN = 069,
		KOREAN_JOHAB = 070,
		LATVIAN = 071,
		LITHUANIAN = 072,
		NORWEGIAN = NOR,
		NORWEGIAN_BOKMAL = 073,
		NORWEGIAN_NYNORSK = 074,
		POLISH = 075,
		PORTUGUESE = POR,
		PORTUGUESE_BRAZIL = 076,
		ROMANIAN = 077,
		RUSSIAN = 078,
		SERBIAN_LATIN = 079,
		SLOVAK = 080,
		SLOVENIAN = 081,
		SPANISH = SPA,
		SPANISH_MEXICAN = 082,
		SPANISH_MODERN = 083,
		SWEDISH = SWE,
		THAI = 084,
		TURKISH = 085,
		UKRANIAN = 086,
		ASSAMESE = 087,
		BENGALI = 088,
		BIHARI = 089,
		BODO = 090,
		DOGRI = 091,
		GUJARATI = 092,
		HARYANVI = 093,
		HINDI = 094,
		KANNADA = 095,
		KASHMIRI = 096,
		MALAYALAM = 097,
		MARATHI = 098,
		MARWARI = 099,
		MEGHALAYAN = 100,
		MIZO = 101,
		NAGA = 102,
		ORISSI = 103,
		PUNJABI = 104,
		PUSHTU = 105,
		SERBIAN_CYRILLIC = 106,
		SIKKIMI = 107,
		SWEDISH_FINLAND = 108,
		TAMIL = 109,
		TELUGU = 110,
		TRIPURI = 111,
		URDU = 112,
		VIETNAMESE = 113,
	}

	public		enum TWCY:short
	{
		AFGHANISTAN = 1001,
		ALGERIA = 0213,
		AMERICANSAMOA = 0684,
		ANDORRA = 0033,
		ANGOLA = 1002,
		ANGUILLA = 8090,
		ANTIGUA = 8091,
		ARGENTINA = 0054,
		ARUBA = 0297,
		ASCENSIONI = 0247,
		AUSTRALIA = 0061,
		AUSTRIA = 0043,
		BAHAMAS = 8092,
		BAHRAIN = 0973,
		BANGLADESH = 0880,
		BARBADOS = 8093,
		BELGIUM = 0032,
		BELIZE = 0501,
		BENIN = 0229,
		BERMUDA = 8094,
		BHUTAN = 1003,
		BOLIVIA = 0591,
		BOTSWANA = 0267,
		BRITAIN = 0006,
		BRITVIRGINIS = 8095,
		BRAZIL = 0055,
		BRUNEI = 0673,
		BULGARIA = 0359,
		BURKINAFASO = 1004,
		BURMA = 1005,
		BURUNDI = 1006,
		CAMAROON = 0237,
		CANADA = 0002,
		CAPEVERDEIS = 0238,
		CAYMANIS = 8096,
		CENTRALAFREP = 1007,
		CHAD = 1008,
		CHILE = 0056,
		CHINA = 0086,
		CHRISTMASIS = 1009,
		COCOSIS = 1009,
		COLOMBIA = 0057,
		COMOROS = 1010,
		CONGO = 1011,
		COOKIS = 1012,
		COSTARICA = 0506,
		CUBA = 0005,
		CYPRUS = 0357,
		CZECHOSLOVAKIA = 0042,
		DENMARK = 0045,
		DJIBOUTI = 1013,
		DOMINICA = 8097,
		DOMINCANREP = 8098,
		EASTERIS = 1014,
		ECUADOR = 0593,
		EGYPT = 0020,
		ELSALVADOR = 0503,
		EQGUINEA = 1015,
		ETHIOPIA = 0251,
		FALKLANDIS = 1016,
		FAEROEIS = 0298,
		FIJIISLANDS = 0679,
		FINLAND = 0358,
		FRANCE = 0033,
		FRANTILLES = 0596,
		FRGUIANA = 0594,
		FRPOLYNEISA = 0689,
		FUTANAIS = 1043,
		GABON = 0241,
		GAMBIA = 0220,
		GERMANY = 0049,
		GHANA = 0233,
		GIBRALTER = 0350,
		GREECE = 0030,
		GREENLAND = 0299,
		GRENADA = 8099,
		GRENEDINES = 8015,
		GUADELOUPE = 0590,
		GUAM = 0671,
		GUANTANAMOBAY = 5399,
		GUATEMALA = 0502,
		GUINEA = 0224,
		GUINEABISSAU = 1017,
		GUYANA = 0592,
		HAITI = 0509,
		HONDURAS = 0504,
		HONGKONG = 0852,
		HUNGARY = 0036,
		ICELAND = 0354,
		INDIA = 0091,
		INDONESIA = 0062,
		IRAN = 0098,
		IRAQ = 0964,
		IRELAND = 0353,
		ISRAEL = 0972,
		ITALY = 0039,
		IVORYCOAST = 0225,
		JAMAICA = 8010,
		JAPAN = 0081,
		JORDAN = 0962,
		KENYA = 0254,
		KIRIBATI = 1018,
		KOREA = 0082,
		KUWAIT = 0965,
		LAOS = 1019,
		LEBANON = 1020,
		LIBERIA = 0231,
		LIBYA = 0218,
		LIECHTENSTEIN = 0041,
		LUXENBOURG = 0352,
		MACAO = 0853,
		MADAGASCAR = 1021,
		MALAWI = 0265,
		MALAYSIA = 0060,
		MALDIVES = 0960,
		MALI = 1022,
		MALTA = 0356,
		MARSHALLIS = 0692,
		MAURITANIA = 1023,
		MAURITIUS = 0230,
		MEXICO = 0003,
		MICRONESIA = 0691,
		MIQUELON = 0508,
		MONACO = 0033,
		MONGOLIA = 1024,
		MONTSERRAT = 8011,
		MOROCCO = 0212,
		MOZAMBIQUE = 1025,
		NAMIBIA = 0264,
		NAURU = 1026,
		NEPAL = 0977,
		NETHERLANDS = 0031,
		NETHANTILLES = 0599,
		NEVIS = 8012,
		NEWCALEDONIA = 0687,
		NEWZEALAND = 0064,
		NICARAGUA = 0505,
		NIGER = 0227,
		NIGERIA = 0234,
		NIUE = 1027,
		NORFOLKI = 1028,
		NORWAY = 0047,
		OMAN = 0968,
		PAKISTAN = 0092,
		PALAU = 1029,
		PANAMA = 0507,
		PARAGUAY = 0595,
		PERU = 0051,
		PHILLIPPINES = 0063,
		PITCAIRNIS = 1030,
		PNEWGUINEA = 0675,
		POLAND = 0048,
		PORTUGAL = 0351,
		QATAR = 0974,
		REUNIONI = 1031,
		ROMANIA = 0040,
		RWANDA = 0250,
		SAIPAN = 0670,
		SANMARINO = 0039,
		SAOTOME = 1033,
		SAUDIARABIA = 0966,
		SENEGAL = 0221,
		SEYCHELLESIS = 1034,
		SIERRALEONE = 1035,
		SINGAPORE = 0065,
		SOLOMONIS = 1036,
		SOMALI = 1037,
		SOUTHAFRICA = 0027,
		SPAIN = 0034,
		SRILANKA = 0094,
		STHELENA = 1032,
		STKITTS = 8013,
		STLUCIA = 8014,
		STPIERRE = 0508,
		STVINCENT = 8015,
		SUDAN = 1038,
		SURINAME = 0597,
		SWAZILAND = 0268,
		SWEDEN = 0046,
		SWITZERLAND = 0041,
		SYRIA = 1039,
		TAIWAN = 0886,
		TANZANIA = 0255,
		THAILAND = 0066,
		TOBAGO = 8016,
		TOGO = 0228,
		TONGAIS = 0676,
		TRINIDAD = 8016,
		TUNISIA = 0216,
		TURKEY = 0090,
		TURKSCAICOS = 8017,
		TUVALU = 1040,
		UGANDA = 0256,
		USSR = 0007,
		UAEMIRATES = 0971,
		UNITEDKINGDOM = 0044,
		USA = 0001,
		URUGUAY = 0598,
		VANUATU = 1041,
		VATICANCITY = 0039,
		VENEZUELA = 0058,
		WAKE = 1042,
		WALLISIS = 1043,
		WESTERNSAHARA = 1044,
		WESTERNSAMOA = 1045,
		YEMEN = 1046,
		YUGOSLAVIA = 0038,
		ZAIRE = 0243,
		ZAMBIA = 0260,
		ZIMBABWE = 0263,
		ALBANIA = 0355,
		ARMENIA = 0374,
		AZERBAIJAN = 0994,
		BELARUS = 0375,
		BOSNIAHERZGO = 0387,
		CAMBODIA = 0855,
		CROATIA = 0385,
		CZECHREPUBLIC = 0420,
		DIEGOGARCIA = 0246,
		ERITREA = 0291,
		ESTONIA = 0372,
		GEORGIA = 0995,
		LATVIA = 0371,
		LESOTHO = 0266,
		LITHUANIA = 0370,
		MACEDONIA = 0389,
		MAYOTTEIS = 0269,
		MOLDOVA = 0373,
		MYANMAR = 0095,
		NORTHKOREA = 0850,
		PUERTORICO = 0787,
		RUSSIA = 0007,
		SERBIA = 0381,
		SLOVAKIA = 0421,
		SLOVENIA = 0386,
		SOUTHKOREA = 0082,
		UKRAINE = 0380,
		USVIRGINIS = 0340,
		VIETNAM = 0084,
	}

	/* ICAP_BITORDER values (BO_ means Bit Order) */
	public		enum TWBO : short 
	{
	LSBFIRST   = 0,
	MSBFIRST   = 1
	}

	/* ICAP_COMPRESSION values (CP_ means ComPression ) */
	public		enum TWCP : short {
	NONE       = 0,
	PACKBITS   = 1,
	GROUP31D   = 2, /* Follows CCITT spec (no End Of Line)          */
	GROUP31DEOL =3, /* Follows CCITT spec (has End Of Line)         */
	GROUP32D    =4, /* Follows CCITT spec (use cap for K Factor)    */
	GROUP4      =5, /* Follows CCITT spec                           */
	JPEG       = 6, /* Use capability for more info                 */
	LZW        = 7, /* Must license from Unisys and IBM to use      */
	JBIG        =8, /* For Bitonal images  -- Added 1.7 KHL         */
	/* Added 1.8 */
	PNG         =9,
	RLE4       = 10,
	RLE8       = 11,
	BITFIELDS  = 12
	}

	/* ICAP_IMAGEFILEFORMAT values (FF_means File Format)   */
	public		enum TWFF : short {
	TIFF      =  0,    /* Tagged Image File Format     */
	PICT      =  1,    /* Macintosh PICT               */
	BMP       =  2,    /* Windows Bitmap               */
	XBM       =  3,    /* X-Windows Bitmap             */
	JFIF      =  4,    /* JPEG File Interchange Format */
	FPX       =  5,    /* Flash Pix                    */
	TIFFMULTI =  6,    /* Multi-page tiff file         */
	PNG       =  7,
	SPIFF     =  8,
	EXIF      =  9
	}

	/* ICAP_FILTER values (F means Filter Type) */
	public		enum TWFT : short {
	RED       =  0,
	GREEN     =  1,
	BLUE      =  2,
	NONE      =  3,
	WHITE     =  4,
	CYAN      =  5,
	MAGENTA   =  6,
	YELLOW    =  7,
	BLACK     =  8
	}

	/* ICAP_LIGHTPATH values (LP_ means Light Path) */
	public		enum TWLP : short {
	REFLECTIVE  = 0,
	TRANSMISSIVE =1
	}

	/* ICAP_LIGHTSOURCE values (LS_ means Light Source) */
	public		enum TWLS : short {
	RED       =  0,
	GREEN     =  1,
	BLUE      =  2,
	NONE      =  3,
	WHITE     =  4,
	UV        =  5,
	IR        =  6
	}

	/* ICAP_ORIENTATION values (OR_ means ORientation) */
	public		enum TWOR : short {
	ROT0      =  0,
	ROT90     =  1,
	ROT180    =  2,
	ROT270    =  3,
	PORTRAIT  =  ROT0,
	LANDSCAPE =  ROT270
	}

	/* ICAP_PLANARCHUNKY values (PC_ means Planar/Chunky ) */
	public		enum TWPC : short {
	CHUNKY    =  0,
	PLANAR    =  1
	}

	/* ICAP_PIXELFLAVOR values (PF_ means Pixel Flavor) */
	public		enum TWPF : short {
	CHOCOLATE =  0,  /* zero pixel represents darkest shade  */
	VANILLA   =  1  /* zero pixel represents lightest shade */
	}

	/* ICAP_PIXELTYPE values (P means Pixel Type) */
	public		enum TWPT : short {
	BW        =  0, /* Black and White */
	GRAY      =  1,
	RGB       =  2,
	PALETTE   =  3,
	CMY       =  4,
	CMYK      =  5,
	YUV       =  6,
	YUVK      =  7,
	CIEXYZ    =  8
	}

	/* ICAP_SUPPORTEDSIZES values (SS_ means Supported Sizes) */
	public		enum TWSS : short {
	NONE      =  0,
	A4LETTER  =  1,
	B5LETTER  =  2,
	USLETTER  =  3,
	USLEGAL   =  4,
	/* Added 1.5 */
	A5        =  5,
	B4        =  6,
	B6        =  7,
	//B          8
	/* Added 1.7 */
	USLEDGER  =  9,
	USEXECUTIVE =10,
	A3          =11,
	B3         = 12,
	A6         = 13,
	C4         = 14,
	C5         = 15,
	C6         = 16,
	/* Added 1.8 */
	_4A0        =  17,
	_2A0        =  18,
	A0         =  19,
	A1         =  20,
	A2         =  21,
	A4         =  A4LETTER,
	A7         =  22,
	A8         =  23,
	A9         =  24,
	A10        =  25,
	ISOB0      =  26,
	ISOB1      =  27,
	ISOB2      =  28,
	ISOB3      =  B3,
	ISOB4      =  B4,
	ISOB5      =  29,
	ISOB6      =  B6,
	ISOB7      =  30,
	ISOB8      =  31,
	ISOB9      =  32,
	ISOB10     =  33,
	JISB0      =  34,
	JISB1      =  35,
	JISB2      =  36,
	JISB3      =  37,
	JISB4      =  38,
	JISB5      =  B5LETTER,
	JISB6      =  39,
	JISB7      =  40,
	JISB8      =  41,
	JISB9      =  42,
	JISB10     =  43,
	C0         =  44,
	C1         =  45,
	C2         =  46,
	C3         =  47,
	C7         =  48,
	C8         =  49,
	C9         =  50,
	C10        =  51,
	USSTATEMENT=  52,
	BUSINESSCARD =53
	}

	/* ICAP_XFERMECH values (SX_ means Setup XFer) */
	public		enum TWSX : short {
	NATIVE     = 0,
	FILE       = 1,
	MEMORY     = 2
	}

	/* ICAP_UNITS values (UN_ means UNits) */
	public		enum TWUN : short {
	INCHES     = 0,
	CENTIMETERS= 1,
	PICAS      = 2,
	POINTS     = 3,
	TWIPS      = 4,
	PIXELS     = 5
	}

	/* Added 1.5 */
	/* ICAP_BITDEPTHREDUCTION values (BR_ means Bitdepth Reduction) */
	public		enum TWBR : short {
	THRESHOLD     =0,
	HALFTONE      =1,
	CUSTHALFTONE  =2,
	DIFFUSION     =3
	}

	/* Added 1.7 */
	/* ICAP_DUPLEX values */
	public		enum TWDX : short {
	NONE         =0,
	_1PASSDUPLEX  =1,
	_2PASSDUPLEX  =2
	}

	/* Added 1.7 */
	/* BARCODETYPE values */
	public		enum TWBT : short {
	_3OF9                 =0,
	_2OF5INTERLEAVED      =1,
	_2OF5NONINTERLEAVED   =2,
	CODE93               =3,
	CODE128              =4,
	UCC128               =5,
	CODABAR              =6,
	UPCA                 =7,
	UPCE                 =8,
	EAN8                 =9,
	EAN13                =10,
	POSTNET              =11,
	PDF417               =12,
	/* Added 1.8 */
	_2OF5INDUSTRIAL       =13,
	_2OF5MATRIX           =14,
	_2OF5DATALOGIC        =15,
	_2OF5IATA             =16,
	_3OF9FULLASCII        =17,
	CODABARWITHSTARTSTOP =18,
	MAXICODE             =19
	}

	/* Added 1.7 */
	/* DESKEWSTATUS values */
	public		enum TWDSK : short {
	SUCCESS     =0,
	REPORTONLY  =1,
	FAIL        =2,
	DISABLED    =3
	}

	/* Added 1.7 */
	/* PATCHCODE values */
	public		enum TWPCH : short {
	PATCH1      =0,
	PATCH2      =1,
	PATCH3      =2,
	PATCH4      =3,
	PATCH6      =4,
	PATCHT      =5
	}

	/* Added 1.7 */
	/* CAP_JOBCONTROL values */
	public		enum TWJC : short {
	NONE   =0,
	JSIC   =1,
	JSIS   =2,
	JSXC   =3,
	JSXS   =4
	}
	                  
	/* Added 1.7 */
	/* BARCODEROTATION values (BCOR_ means barcode rotation) */
	public		enum TWBCOR : short {
	ROT0   =0,
	ROT90  =1,
	ROT180 =2,
	ROT270 =3,
	ROTX   =4
	}

	/* Added 1.8 */
	/* ACAP_AUDIOFILEFORMAT values (AF_ means audio format) */
	public		enum TWAF : short {
	WAV      =0,
	AIFF     =1,
	AU       =3,
	SND      =4
	}

	/* CAP_ALARMS values (AL_ means alarms) */
	public		enum TWAL : short {
	ALARM          =0,
	FEEDERERROR    =1,
	FEEDERWARNING  =2,
	BARCODE        =3,
	DOUBLEFEED     =4,
	JAM            =5,
	PATCHCODE      =6,
	POWER          =7,
	SKEW           =8
	}

	/* CAP_CLEARBUFFERS values (CB_ means clear buffers) */
	public		enum TWCB : short {
	AUTO           =0,
	CLEAR          =1,
	NOCLEAR        =2
	}

	/* CAP_DEVICEEVENT values (DE_ means device event) */
	public		enum TWDE  {
	CUSTOMEVENTS           =0x8000,      
	CHECKAUTOMATICCAPTURE  =0,
	CHECKBATTERY           =1,
	CHECKDEVICEONLINE      =2,
	CHECKFLASH             =3,
	CHECKPOWERSUPPLY       =4,
	CHECKRESOLUTION        =5,
	DEVICEADDED            =6,
	DEVICEOFFLINE          =7,
	DEVICEREADY            =8,
	DEVICEREMOVED          =9,
	IMAGECAPTURED          =10,
	IMAGEDELETED           =11,
	PAPERDOUBLEFEED        =12,
	PAPERJAM               =13,
	LAMPFAILURE            =14,
	POWERSAVE              =15,
	POWERSAVENOTIFY        =16
	}

	/* CAP_FEEDERALIGNMENT values (FA_ means feeder alignment) */
	public		enum TWFA : short {
	NONE   =0,
	LEFT   =1,
	CENTER =2,
	RIGHT  =3
	}

	/* CAP_FEEDERORDER values (FO_ means feeder order) */
	public		enum TWFO : short {
	FIRSTPAGEFIRST =0,
	LASTPAGEFIRST  =1
	}

	/* CAP_FILESYSTEM values (FS_ means file system) */
	public		enum TWFS : short {
	FILESYSTEM       =0,
	RECURSIVEDELETE  =1
	}

	/* CAP_POWERSUPPLY values (PS_ means power supply) */
	public		enum TWPS : short {
	EXTERNAL =0,
	BATTERY  =1
	}

	/* CAP_PRINTER values (PR_ means printer) */
	public		enum TWPR : short {
	IMPRINTERTOPBEFORE    = 0,
	IMPRINTERTOPAFTER     = 1,
	IMPRINTERBOTTOMBEFORE = 2,
	IMPRINTERBOTTOMAFTER  = 3,
	ENDORSERTOPBEFORE     = 4,
	ENDORSERTOPAFTER      = 5,
	ENDORSERBOTTOMBEFORE  = 6,
	ENDORSERBOTTOMAFTER   = 7
	}

	/* CAP_PRINTERMODE values (PM_ means printer mode) */
	public		enum TWPM : short {
	SINGLESTRING    = 0,
	MULTISTRING     = 1,
	COMPOUNDSTRING   =2
	}

	/* ICAP_BARCODESEARCHMODE values ( means search) */
	public		enum TWBD : short {
	HORZ     =0,
	VERT     =1,
	HORZVERT =2,
	VERTHORZ =3
	}

	/* ICAP_FLASHUSED2 values (FL_ means flash) */
	public		enum TWFL : short {
	NONE     =0,
	OFF      =1,
	ON       =2,
	AUTO     =3,
	REDEYE   =4
	}

	/* ICAP_FLIPROTATION values (FR_ means flip rotation) */
	public		enum TWFR : short {
	BOOK     =0,
	FANFOLD  =1
	}

	/* ICAP_IMAGEFILTER values (IF_ means image filter) */
	public		enum TWIF : short {
	NONE     =0,
	AUTO     =1,
	LOWPASS  =2,
	BANDPASS =3,
	HIGHPASS =4,
	TEXT     =BANDPASS,
	FINELINE =HIGHPASS
	}

	/* ICAP_NOISEFILTER values (NF_ means noise filter) */
	public		enum TWNF : short {
	NONE         =0,
	AUTO         =1,
	LONEPIXEL    =2,
	MAJORITYRULE =3
	}

	/* ICAP_OVERSCAN values (OV_ means overscan) */
	public		enum TWOV : short {
	NONE       =0,
	AUTO       =1,
	TOPBOTTOM  =2,
	LEFTRIGHT  =3,
	ALL        =4
	}

	/* FILESYSTEM.FileType values (F means file type) */
	public		enum TWFY : short {
	CAMERA        = 0,
	CAMERATOP      =1,
	CAMERABOTTOM   =2,
	CAMERAPREVIEW  =3,
	DOMAIN         =4,
	HOST           =5,
	DIRECTORY      =6,
	IMAGE          =7,
	UNKNOWN        =8
	}


}
